package com.tofly.yxpc.base;

import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.yxpc.entity.DictEntity;
import com.tofly.yxpc.entity.TwdhEntity;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.entity.base.FileResponse;
import com.tofly.yxpc.entity.user.LoginBean;
import com.tofly.yxpc.entity.user.UserInfo;
import com.tofly.yxpc.utils.update.VersionInfo;

import java.util.List;
import java.util.Map;

import io.reactivex.Observable;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.Multipart;
import retrofit2.http.POST;
import retrofit2.http.PUT;
import retrofit2.http.Part;
import retrofit2.http.PartMap;
import retrofit2.http.Query;

/**
 * @author ychk
 */
public interface Api {

    /**
     * 登录
     */
    @POST("api/auth/login")
    Observable<LoginBean> login(@Body RequestBody body);

    /**
     * 分页查询水表
     */
    @POST("api/yt/dict_item/find")
    Observable<List<DictEntity>> getdictItem(@Body RequestBody body);

    @Multipart
    @POST("api/yt/yxswWaterNotInspect")
    Observable<BaseResponse> uploadWaterNotInspect(@Part List<MultipartBody.Part> file,@Part List<MultipartBody.Part> bpfilelist,@PartMap Map<String, RequestBody> yxswWaterNotInspect);
    @Multipart
    @POST("api/yt/yxswWaterNotInspect")
    Observable<BaseResponse> uploadWaterNotInspect(@Part List<MultipartBody.Part> file,@PartMap Map<String, RequestBody> yxswWaterNotInspect);

    @Multipart
    @POST("api/yt/yxswWaterTwNavigation")
    Observable<BaseResponse> uploadWaterTwNavigation(@PartMap Map<String, RequestBody> yxswWaterTwNavigation, @Part List<MultipartBody.Part> mapfilelist, @Part List<MultipartBody.Part> file);

    @Multipart
    @POST("api/yt/yxswWaterMeterInspect/updateBatchByCus")
    Observable<BaseResponse> updateBatchByCus(@PartMap Map<String, RequestBody> yxswWaterMeterInspectUpload, @Part List<MultipartBody.Part> bpFileList, @Part List<MultipartBody.Part> exceptionFileList, @Part List<MultipartBody.Part> wfbdFileList);

    @POST("api/yt/yxswWaterTwNavigation/list")
    Observable<BaseResponse<List<TwdhEntity>>> getWaterTwNavigation(@Body RequestBody body);

    @GET("api/yt/yxswWaterMeterTask/taskDownload")
    Observable<BaseResponse<List<WaterMeterTaskEntity>>> taskDownload(@Query("userId") String userId);

    /**
     * 获取用户基本信息
     */
    @GET("api/yt/user/me/info")
    Observable<UserInfo> getUserInfo();

    /**
     * 获取app版本
     */
    @POST("api/yt/yxswAppVersion/page")
    Observable<VersionInfo> getAppVersion(@Body RequestBody body);

    /**
     * 修改密码
     */
    @POST("api/yt/user/reset")
    Observable<BaseResponse> resetPwd(@Body RequestBody body);

    /**
     * 修改用户信息
     */
    @PUT("api/yt/user/center")
    Observable<BaseResponse> updateUser(@Body RequestBody body);

    /**
     * 上传附件
     */
    @Multipart
    @POST("api/yt/fileStorage/upload")
    Observable<FileResponse> submitFile(@PartMap Map<String, RequestBody> map);
}
