package com.tofly.yxpc.entity;

import org.greenrobot.greendao.annotation.Convert;
import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;
import java.util.List;
import org.greenrobot.greendao.annotation.Generated;

@Entity
public class TwdhEntity {
    @Id
    private Long id;
    /**
     * 图文导航命名
     */
    private String name;
    /**
     * 状态；0：未开始，1：已稽查，2：已上传
     */
    private int check_state;
    /**
     * 图文导航描述
     */
    private String describe;
    /**
     * 稽查人
     */
    private String check_user;
    @Convert(columnType = String.class, converter = FileConverter.class)
    private List<FileBean> fileList;
    @Convert(columnType = String.class, converter = FileConverter.class)
    private List<FileBean> mapFileList;
    private int nspect_id;
    /**
     * "0":保存本地，null:已上传
     */
    private String state;
    private String waterNavigationInspects;
    @Generated(hash = 1886988967)
    public TwdhEntity(Long id, String name, int check_state, String describe,
            String check_user, List<FileBean> fileList, List<FileBean> mapFileList,
            int nspect_id, String state, String waterNavigationInspects) {
        this.id = id;
        this.name = name;
        this.check_state = check_state;
        this.describe = describe;
        this.check_user = check_user;
        this.fileList = fileList;
        this.mapFileList = mapFileList;
        this.nspect_id = nspect_id;
        this.state = state;
        this.waterNavigationInspects = waterNavigationInspects;
    }
    @Generated(hash = 1074490059)
    public TwdhEntity() {
    }
    public Long getId() {
        return this.id;
    }
    public void setId(Long id) {
        this.id = id;
    }
    public String getName() {
        return this.name;
    }
    public void setName(String name) {
        this.name = name;
    }
    public int getCheck_state() {
        return this.check_state;
    }
    public void setCheck_state(int check_state) {
        this.check_state = check_state;
    }
    public String getDescribe() {
        return this.describe;
    }
    public void setDescribe(String describe) {
        this.describe = describe;
    }
    public String getCheck_user() {
        return this.check_user;
    }
    public void setCheck_user(String check_user) {
        this.check_user = check_user;
    }
    public List<FileBean> getFileList() {
        return this.fileList;
    }
    public void setFileList(List<FileBean> fileList) {
        this.fileList = fileList;
    }
    public List<FileBean> getMapFileList() {
        return this.mapFileList;
    }
    public void setMapFileList(List<FileBean> mapFileList) {
        this.mapFileList = mapFileList;
    }
    public int getNspect_id() {
        return this.nspect_id;
    }
    public void setNspect_id(int nspect_id) {
        this.nspect_id = nspect_id;
    }
    public String getState() {
        return this.state;
    }
    public void setState(String state) {
        this.state = state;
    }
    public String getWaterNavigationInspects() {
        return this.waterNavigationInspects;
    }
    public void setWaterNavigationInspects(String waterNavigationInspects) {
        this.waterNavigationInspects = waterNavigationInspects;
    }

}
