package com.tofly.yxpc.entity;

import android.text.TextUtils;

import com.alibaba.fastjson.JSON;

import org.greenrobot.greendao.converter.PropertyConverter;

import java.util.ArrayList;
import java.util.List;

/**
 * @author 76486
 */
public class WaterMeterConverter implements PropertyConverter<List<WaterMeterEntity>, String> {
    @Override
    public List<WaterMeterEntity> convertToEntityProperty(String databaseValue) {
        if (TextUtils.isEmpty(databaseValue)) {
            return null;
        } else {
            String[] listStr = databaseValue.split("~");
            List<WaterMeterEntity> list = new ArrayList<>();
            for (String s : listStr) {
                list.add(JSON.parseObject(s, WaterMeterEntity.class));
            }
            return list;
        }
    }

    @Override
    public String convertToDatabaseValue(List<WaterMeterEntity> entityProperty) {
        if (entityProperty == null) {
            return null;
        } else {
            StringBuilder builder = new StringBuilder();
            for (WaterMeterEntity t : entityProperty) {
                String str = JSON.toJSONString(t);
                builder.append(str).append("~");
            }
            return builder.toString();
        }
    }
}
