package com.tofly.yxpc.map;

import android.content.Context;

import com.amap.api.maps.CoordinateConverter;
import com.amap.api.maps.model.LatLng;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author ychk
 */
public class LocationUtil_xu implements Serializable {
    private static final double a = 6378245.0;//长半轴
    private static final double ee = 0.00669342162296594323;//扁率

    public static CoordinateClass gcj02towgs84(Double lng, Double lat) {
//        if (out_of_china(lng,lat)) {
//            return null;
//        }
//
//        double dlat = transformlat(lng - 105.0, lat - 35.0);
//        double dlng = transformlng(lng - 105.0, lat - 35.0);
//        double radlat = lat / 180.0 * Math.PI;
//        double magic = Math.sin(radlat);
//        magic = 1 - ee * magic * magic;
//        double sqrtmagic = Math.sqrt(magic);
//        dlat = (dlat * 180.0) / ((a * (1 - ee)) / (magic * sqrtmagic) * Math.PI);
//        dlng = (dlng * 180.0) / (a / sqrtmagic * Math.cos(radlat) * Math.PI);
//        double mglat = lat + dlat;
//        double mglng = lng + dlng;
//        return new CoordinateClass(lng*2-mglng,lat*2-mglat);
        return new CoordinateClass(lng, lat);
    }

    private static double transformlat(Double lng, Double lat) {
        double ret = -100.0 + 2.0 * lng + 3.0 * lat + 0.2 * lat * lat + 0.1 * lng * lat + 0.2 * Math.sqrt(Math.abs(lng));
        ret += (20.0 * Math.sin(6.0 * lng * Math.PI) + 20.0 *
                Math.sin(2.0 * lng * Math.PI)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(lat * Math.PI) + 40.0 *
                Math.sin(lat / 3.0 * Math.PI)) * 2.0 / 3.0;
        ret += (160.0 * Math.sin(lat / 12.0 * Math.PI) + 320 *
                Math.sin(lat * Math.PI / 30.0)) * 2.0 / 3.0;
        return ret;
    }

    private static double transformlng(Double lng, Double lat) {
        double ret = 300.0 + lng + 2.0 * lat + 0.1 * lng * lng + 0.1 * lng * lat + 0.1 * Math.sqrt(Math.abs(lng));
        ret += (20.0 * Math.sin(6.0 * lng * Math.PI) + 20.0 *
                Math.sin(2.0 * lng * Math.PI)) * 2.0 / 3.0;
        ret += (20.0 * Math.sin(lng * Math.PI) + 40.0 *
                Math.sin(lng / 3.0 * Math.PI)) * 2.0 / 3.0;
        ret += (150.0 * Math.sin(lng / 12.0 * Math.PI) + 300.0 *
                Math.sin(lng / 30.0 * Math.PI)) * 2.0 / 3.0;
        return ret;
    }

    private static boolean out_of_china(Double lng, Double lat) {
        if (lng < 72.004 || lng > 137.8347) {
            return true;
        }
        return lat < 0.8293 || lat > 55.8271;
    }

    public static class CoordinateClass implements Serializable {
        public Double Longtitude;
        public Double Latitude;
        public String addr;

        public CoordinateClass(double lng, double lat) {
            Longtitude = lng;
            Latitude = lat;
        }

        public CoordinateClass(double lng, double lat, String addr) {
            Longtitude = lng;
            Latitude = lat;
            this.addr = addr;
        }
    }

    public static LatLng wgs84togcj02(Context context, double lng, double lat) {
//        LatLng amapPoint = null;
//        CoordinateConverter converter = new CoordinateConverter(context);
//        converter.from(CoordinateConverter.CoordType.GPS);
//        try {
//            converter.coord(new LatLng(lat, lng));
//            amapPoint = converter.convert();
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        return amapPoint;
        return new LatLng(lat, lng);
    }

    /**
     * 格式化经纬度数据为字符串，保留小数点后6位
     *
     * @param num 输入的经/纬度
     */
    public static String formatLocation(double num) {
        return String.format("%.6f", num);
    }

    public static double formatLocationDouble(double input) {
        double out;
        try {
            BigDecimal b = new BigDecimal(input);
            out = b.setScale(6, BigDecimal.ROUND_HALF_UP).doubleValue();
        } catch (RuntimeException e) {
            out = input;
        }
        return out;
    }
}
