package com.tofly.yxpc.ui.activity;

import android.content.Intent;
import android.os.Bundle;
import android.widget.TextView;
import androidx.appcompat.widget.Toolbar;
import com.bumptech.glide.Glide;
import com.tofly.latte_core.base.LatteActivity;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.yxpc.R;
import com.tofly.yxpc.utils.ImageUtil;
import com.tofly.yxpc.widget.GestureImageView;
import java.util.List;
import butterknife.BindView;

/**
 * @author ychk
 */
public class BigImageActivity extends LatteActivity {

    @BindView(R.id.image)
    GestureImageView image;
    @BindView(R.id.tv_toolbar_title)
    TextView tvToolbarTitle;
    @BindView(R.id.toolbar)
    Toolbar toolbar;

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return null;
    }

    @Override
    public Object setLayout() {
        return R.layout.activity_big_image;
    }

    @Override
    public void initView() {
        initToolBar(toolbar, tvToolbarTitle, "大图");
        initData();
    }

    private void initData() {
        Intent intent = getIntent();
        boolean isWhite = intent.getBooleanExtra("isWhite", false);
        if (isWhite) {
            image.setBackgroundColor(getResources().getColor(R.color.white));
        } else {
            image.setBackgroundColor(getResources().getColor(R.color.black));
        }
        Bundle bundle = intent.getExtras();
        if (bundle != null) {
            List<String> pictures = bundle.getStringArrayList(ImageUtil.PICS_PATH_KEY);
            if (pictures != null && pictures.size() > 0) {
                Glide.with(this)
                        .load(pictures.get(0))
                        .into(image);
            }
        }
    }

}
