package com.tofly.yxpc.ui.activity;

import android.content.Intent;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.MotionEvent;

import androidx.annotation.Nullable;

import com.amap.api.maps.AMap;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.latte_core.config.Constants;
import com.tofly.yxpc.base.MyApp;
import com.tofly.yxpc.databinding.ActivityScreenshotBinding;
import com.tofly.yxpc.map.LocationUtil_xu;
import com.tofly.yxpc.utils.BitmapUtils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import cn.hzw.graffiti.GraffitiActivity;


/**
 * @author 76486
 */
public class ScreenshotActivity extends PhotoActivity {

    private ActivityScreenshotBinding binding;

    @Override
    public void onTakePhotoSuccess(String pathFile) {

    }

    @Override
    public void onTakeVideoSuccess(String videoFile) {

    }

    @Override
    public Object setLayout() {
        binding = ActivityScreenshotBinding.inflate(getLayoutInflater());
        return binding.getRoot();
    }

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return null;
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        setIsLocation(false);
        super.onCreate(savedInstanceState);
    }

    @Override
    public void initView() {
        initToolBar(binding.llToolbar.toolbar, binding.llToolbar.tvToolbarTitle, "地图");
        binding.tvJt.setOnClickListener(v -> {
            aMap.getMapScreenShot(new AMap.OnMapScreenShotListener() {
                @Override
                public void onMapScreenShot(Bitmap bitmap) {
                    if (null == bitmap) {
                        return;
                    }
                    File file = saveImageToFile(bitmap);
                    takeGraffiti(file.getPath());
                }

                @Override
                public void onMapScreenShot(Bitmap bitmap, int status) {

                }
            });

        });

    }

    @Override
    public void initMapView() {
        super.initMapView();
        aMap.setOnMapTouchListener(motionEvent -> binding.mapView.requestDisallowInterceptTouchEvent(motionEvent.getAction() != MotionEvent.ACTION_UP));
        aMap.setOnCameraChangeListener(mapCameraChangeListener);
        binding.imgMap.setOnClickListener(v -> checkMap());
        binding.imgLocation.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime() && lo != null) {
                moveOrigin(lo.Longtitude, lo.Latitude, aMap.getCameraPosition().zoom);
            }
        });
    }

    @Override
    public void initMapListener(LocationUtil_xu.CoordinateClass info) {
        super.initMapListener(info);
    }

    @Override
    public void finishLocation() {
        super.finishLocation();
        if (lo != null) {
            moveOrigin(lo.Longtitude, lo.Latitude, 17);
            aMap.addMarker(setMark(lo.Longtitude, lo.Latitude, "1"));
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == REQ_CODE_DOODLE) {
            if (resultCode == GraffitiActivity.RESULT_OK) {
                if (data != null) {
                    String path = data.getStringExtra(GraffitiActivity.KEY_IMAGE_PATH);
                    BitmapUtils.compressImage(path);
                    Intent intent = new Intent();
                    intent.putExtra("path", path);
                    setResult(0, intent);
                    finish();
                } else {
                    onMessage("获取图片失败");
                }
            } else {
                onMessage("获取图片失败");
            }
        }
    }

    public File saveImageToFile(Bitmap bmp) {
        File appDir = new File(Constants.PHOTO_PATH);
        if (!appDir.isDirectory()) {
            appDir.mkdirs();
        }
        String fileName = System.currentTimeMillis() + ".jpg";
        File file = new File(appDir, fileName);
        try {
            FileOutputStream fos = new FileOutputStream(file);
            bmp.compress(Bitmap.CompressFormat.JPEG, 100, fos);
            fos.flush();
            fos.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return file;
    }
}
