package com.tofly.yxpc.ui.activity;

import android.content.Intent;
import android.view.View;
import android.widget.TextView;

import androidx.appcompat.widget.Toolbar;

import com.tofly.latte_core.base.LatteActivity;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.latte_core.config.Constants;
import com.tofly.latte_core.utils.AccountManager;
import com.tofly.yxpc.R;
import com.tofly.yxpc.base.MyApp;
import com.tofly.yxpc.widget.SignatureView;

import butterknife.BindView;
import butterknife.OnClick;

/**
 * @author ychk
 */
public class SignatureActivity extends LatteActivity {

    @BindView(R.id.tv_toolbar_title)
    TextView tvToolbarTitle;
    @BindView(R.id.toolbar)
    Toolbar toolbar;
    @BindView(R.id.sv_signature)
    SignatureView svSignature;

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return null;
    }

    @Override
    public Object setLayout() {
        return R.layout.activity_signature;
    }

    @Override
    public void initView() {
        initToolBar(toolbar, tvToolbarTitle, "请在空白处手写签字");
    }

    @OnClick({R.id.tv_signature, R.id.tv_submit})
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.tv_signature:
                svSignature.clear();
                break;
            case R.id.tv_submit:
                String name = AccountManager.getUserId() + "_" + System.currentTimeMillis() + ".png";
                if (MyApp.getInstance().isOverTime() && svSignature.save(name)) {
                    Intent intent = new Intent();
                    intent.putExtra("path", Constants.SIGNATURE_PATH + name);
                    setResult(1089, intent);
                    finish();
                } else {
                    onMessage("签名不能为空");
                }
                break;
            default:
                break;
        }
    }
}
