package com.tofly.yxpc.ui.activity;

import android.content.Intent;
import android.os.Build;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.MotionEvent;
import android.view.View;
import android.widget.TextView;

import androidx.annotation.RequiresApi;

import com.alibaba.fastjson.JSONArray;
import com.amap.api.maps.model.LatLng;
import com.amap.api.maps.model.Marker;
import com.amap.api.maps.model.PolygonOptions;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.yxpc.R;
import com.tofly.yxpc.base.MyApp;
import com.tofly.yxpc.databinding.ActivityTaskBinding;
import com.tofly.yxpc.entity.BaseUpdataEntity;
import com.tofly.yxpc.entity.WaterMeterEntity;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.greenDao.WaterMeterEntityDao;
import com.tofly.yxpc.map.LocationUtil_xu;
import com.tofly.yxpc.map.gaode.NavitHelper;
import com.tofly.yxpc.ui.adapter.TaskAdapter;
import com.tofly.yxpc.utils.RecyclerViewUtils;
import com.tofly.yxpc.utils.db.DaoUtilsStore;

import java.util.ArrayList;
import java.util.List;

/**
 * @author 76486
 */
public class TaskActivity extends PhotoActivity {

    private ActivityTaskBinding binding;
    private TaskAdapter adapter;
    private List<WaterMeterEntity> list;
    /**
     * 0:未开始，1：草稿，2：本地保存，3：已提交
     */
    private int type = 0;
    private final List<TextView> numList = new ArrayList<>();
    private final List<TextView> nameList = new ArrayList<>();
    private WaterMeterTaskEntity waterMeterTaskEntity;
    /**
     * 任务点跳转值
     */
    private LocationUtil_xu.CoordinateClass loTask = null;
    private NavitHelper navitHelper = null;
    private Marker locationMarker = null;
    /**
     * 阳新定位点
     */
    private LatLng taskPoint = null;


    @Override
    public void onTakePhotoSuccess(String pathFile) {

    }

    @Override
    public void onTakeVideoSuccess(String videoFile) {

    }

    @Override
    public Object setLayout() {
        binding = ActivityTaskBinding.inflate(getLayoutInflater());
        return binding.getRoot();
    }

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return null;
    }

    @Override
    public void initView() {
        setIsLocation(false);
        setType("1");
        long id = getIntent().getLongExtra("Id", 0);
        waterMeterTaskEntity = DaoUtilsStore.getInstance().getWaterMeterTaskEntityDbUtils().queryById(id);
        initToolBar(binding.llToolbar.toolbar, binding.llToolbar.tvToolbarTitle, waterMeterTaskEntity.getTaskName());
        navitHelper = new NavitHelper(this);
        getTextView();
        initRecyclerView();
        initListener();
    }

    private void getTextView() {
        numList.add(binding.tvNoStartNum);
        numList.add(binding.tvDraftNum);
        numList.add(binding.tvLocalNum);
        numList.add(binding.tvCommitNum);
        nameList.add(binding.tvNoStartName);
        nameList.add(binding.tvDraftName);
        nameList.add(binding.tvLocalName);
        nameList.add(binding.tvCommitName);
        binding.tvNoStartNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(0))));
        binding.tvDraftNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(1))));
        binding.tvLocalNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(2))));
        binding.tvCommitNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(3))));
        binding.llMap.imgNavit.setVisibility(View.VISIBLE);
    }

    private void initRecyclerView() {
        list = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(type));
        adapter = new TaskAdapter(list);
        RecyclerViewUtils.initLinerV(this, binding.rvList, adapter, true, 0);
    }

    private void initListener() {
        binding.llNoStart.setOnClickListener(v -> {
            type = 0;
            list.clear();
            initColor();
            getData();
        });
        binding.llDraft.setOnClickListener(v -> {
            type = 1;
            list.clear();
            initColor();
            getData();
        });
        binding.llLocal.setOnClickListener(v -> {
            type = 2;
            initColor();
            list.clear();
            getData();
        });
        binding.llCommit.setOnClickListener(v -> {
            type = 3;
            initColor();
            list.clear();
            getData();
        });
        binding.etSearch.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                getData();
            }
        });

        binding.tvUnregister.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime()) {
                //   getData();
                startActivity(new Intent(this, UnRegisterActivity.class));
            }
        });
        binding.etSearch.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!TextUtils.isEmpty(s)) {
                    list = DaoUtilsStore.getInstance()
                            .getWaterMeterEntityDbUtils()
                            .queryByQueryBuilderAndOr(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId())
                                    , WaterMeterEntityDao.Properties.UserNum.like("%" + s + "%")
                                    , WaterMeterEntityDao.Properties.UserName.like("%" + s + "%")
                                    , WaterMeterEntityDao.Properties.UserAddr.like("%" + s + "%")
                            );
                    adapter.setNewData(list);
                } else {
                    list.clear();
                    getData();
                }
            }
        });
        adapter.setOnItemClickListener((adapter1, view, position) -> {
            Intent intent = new Intent(this, TaskDetailActivity.class);
            intent.putExtra("Id", list.get(position).getId());
            BaseUpdataEntity baseUpdataEntity = DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().queryById(list.get(position).getId());
            if (baseUpdataEntity != null) {
                intent.putExtra("type", baseUpdataEntity.getType());
            }
            startActivity(intent);
        });
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        binding.tvNoStartNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(0))));
        binding.tvDraftNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(1))));
        binding.tvLocalNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(2))));
        binding.tvCommitNum.setText(String.valueOf(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(3))));
        getData();
    }

    private void initColor() {
        for (int i = 0; i < 4; i++) {
            if (i == type) {
                numList.get(i).setTextColor(getResources().getColor(R.color.blue));
                nameList.get(i).setTextColor(getResources().getColor(R.color.blue));
            } else {
                numList.get(i).setTextColor(getResources().getColor(R.color.color_333));
                nameList.get(i).setTextColor(getResources().getColor(R.color.color_333));
            }
        }
    }

    private void getData() {
        list = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(waterMeterTaskEntity.getId()), WaterMeterEntityDao.Properties.State.eq(type));
        adapter.setNewData(list);
    }

    @RequiresApi(api = Build.VERSION_CODES.M)
    @Override
    public void initMapView() {
        super.initMapView();
        binding.llMap.imgFw.setVisibility(View.VISIBLE);
        aMap.setOnMapTouchListener(motionEvent -> binding.llMap.mapView.requestDisallowInterceptTouchEvent(motionEvent.getAction() != MotionEvent.ACTION_UP));
        binding.llMap.imgAllScreen.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime()) {
                Intent intent = new Intent(this, LocationActivity.class);
                intent.putExtra("locationUtilXuNew", loTask);
                intent.putExtra("latLngs", waterMeterTaskEntity.getTaskRange());
                intent.putExtra("isRed", "0");
                intent.putExtra("isDrag", false);
                startActivity(intent);
            }
        });
        binding.llMap.imgLocation.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime() && lo != null) {
                moveOrigin(lo.Longtitude, lo.Latitude, aMap.getCameraPosition().zoom);
                if (locationMarker != null) {
                    locationMarker.remove();
                }
                locationMarker = aMap.addMarker(setMark(lo.Longtitude, lo.Latitude, "1"));
            }
        });
        binding.llMap.imgFw.setOnClickListener(v -> moveOrigin(taskPoint.longitude, taskPoint.latitude, aMap.getCameraPosition().zoom));
        binding.llMap.imgMap.setOnClickListener(v -> checkMap());
        if (!TextUtils.isEmpty(waterMeterTaskEntity.getLongitude()) && !TextUtils.isEmpty(waterMeterTaskEntity.getLatitude())) {
            loTask = new LocationUtil_xu.CoordinateClass(Double.parseDouble(waterMeterTaskEntity.getLongitude())
                    , Double.parseDouble(waterMeterTaskEntity.getLatitude()));
            taskPoint = new LatLng(loTask.Latitude, loTask.Longtitude);
            moveOrigin(taskPoint.longitude, taskPoint.latitude, 16);
            aMap.addMarker(setMark(loTask.Longtitude, loTask.Latitude, "0"));
        }
        if (MyApp.getInstance().isOverTime() && lo != null) {
            aMap.clear();
            aMap.addMarker(setMark(lo.Longtitude, lo.Latitude, "1"));
        }
        binding.llMap.imgNavit.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime() && lo != null && loTask != null) {
                navitHelper.naviSearchAddr(new LatLng(lo.Latitude, lo.Longtitude), new LatLng(loTask.Latitude, loTask.Longtitude));
            } else {
                onMessage("当前任务无位置信息，无法导航！");
            }
        });
        if (waterMeterTaskEntity.getTaskRange() != null && waterMeterTaskEntity.getTaskRange().length() > 2) {
            List<LatLng> latLngs = new ArrayList<>();
            List<ArrayList> list = JSONArray.parseArray(waterMeterTaskEntity.getTaskRange(), ArrayList.class);
            for (ArrayList bean : list) {
                latLngs.clear();
                List<String[]> strings = JSONArray.parseArray(bean.toString(), String[].class);
                for (String[] strings1 : strings) {
                    double longitude = Double.parseDouble(strings1[0]);
                    double latitude = Double.parseDouble(strings1[1]);
                    latLngs.add(new LatLng(latitude, longitude));
                }
                // 声明 多边形参数对象
                PolygonOptions polygonOptions = new PolygonOptions();
// 添加 多边形的每个顶点（顺序添加）
                polygonOptions.addAll(latLngs);
                polygonOptions.strokeWidth(5) // 多边形的边框
                        .strokeColor(getColor(R.color.red2)) // 边框颜色
                        .fillColor(getColor(R.color.red3));   // 多边形的填充色
                aMap.addPolygon(polygonOptions);
            }
            if (!latLngs.isEmpty()) {
                LatLng center = latLngs.get(0);
                if (loTask == null && center != null && center.longitude != 0 && center.latitude != 0) {
                    taskPoint = center;
                    moveOrigin(taskPoint.longitude, taskPoint.latitude, 16);
                }
            }
        } else {
            if (loTask == null) {
                taskPoint = new LatLng(29.83062932, 115.21583523);
                moveOrigin(taskPoint.longitude, taskPoint.latitude, 16);
            }
        }
    }

}
