package com.tofly.yxpc.ui.activity;

import android.content.Intent;
import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.yxpc.R;
import com.tofly.yxpc.databinding.ActivityTaskDetailBinding;
import com.tofly.yxpc.entity.WaterMeterEntity;
import com.tofly.yxpc.ui.adapter.ListPageAdapter;
import com.tofly.yxpc.ui.fragment.UnCalibrateFragment;
import com.tofly.yxpc.ui.fragment.WaterCheckFragment;
import com.tofly.yxpc.ui.impl.MainImpl;
import com.tofly.yxpc.utils.db.DaoUtilsStore;

import java.util.ArrayList;
import java.util.List;

/**
 * @author 76486
 */
public class TaskDetailActivity extends PhotoActivity {

    private ActivityTaskDetailBinding binding;
    private ListPageAdapter listPageAdapter;
    private WaterCheckFragment waterCheckFragment;
    private UnCalibrateFragment unCalibrateFragment;
    private WaterMeterEntity sbdjEntity = null;
    private int type;

    @Override
    public void onTakePhotoSuccess(String pathFile) {

    }

    @Override
    public void onTakeVideoSuccess(String videoFile) {

    }

    @Override
    public Object setLayout() {
        binding = ActivityTaskDetailBinding.inflate(getLayoutInflater());
        return binding.getRoot();
    }

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return new MainImpl();
    }

    @Override
    public void initView() {
        long id = getIntent().getLongExtra("Id", 0);
        type = getIntent().getIntExtra("type", 0);
        sbdjEntity = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryById(id);
        initToolBar(binding.llToolbar.toolbar, binding.llToolbar.tvToolbarTitle, "水表稽查（" + sbdjEntity.getWaterMeterNum() + "）");
        initTabLayout();
    }

    private void initTabLayout() {
        String[] strings = {"稽查", "无法标定"};
        int[] ints = {R.mipmap.icon_jc, R.mipmap.icon_wf};
        List<Fragment> fragmentList = new ArrayList<>();
        waterCheckFragment = new WaterCheckFragment();
        unCalibrateFragment = new UnCalibrateFragment();
        Bundle bundle = new Bundle();
        if (sbdjEntity != null) {
            bundle.putLong("Id", sbdjEntity.getId());
        }
        waterCheckFragment.setArguments(bundle);//数据传递到fragment中
        unCalibrateFragment.setArguments(bundle);//数据传递到fragment中
        fragmentList.add(waterCheckFragment);
        fragmentList.add(unCalibrateFragment);
        listPageAdapter = new ListPageAdapter(getSupportFragmentManager(), strings, ints, fragmentList);
        binding.viewPager.setAdapter(listPageAdapter);
        binding.viewPager.setOffscreenPageLimit(2);
        binding.tabLayout.setupWithViewPager(binding.viewPager);
        for (int i = 0; i < binding.tabLayout.getTabCount(); i++) {
            binding.tabLayout.getTabAt(i).setCustomView(listPageAdapter.getTabView(i, this));
        }
        if (type == 2) {
            binding.viewPager.setCurrentItem(1);
        } else {
            binding.viewPager.setCurrentItem(0);
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 49374 && resultCode == RESULT_OK) {
            IntentResult result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
            if (waterCheckFragment != null) {
                if (result != null && result.getContents() != null) {
                    waterCheckFragment.setQc(result.getContents());
                } else {
                    waterCheckFragment.setQc("");
                }
            }
        }
    }
}
