package com.tofly.yxpc.ui.activity;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import androidx.annotation.Nullable;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.latte_core.utils.AccountManager;
import com.tofly.latte_core.utils.NetworkUtil;
import com.tofly.yxpc.base.MyApp;
import com.tofly.yxpc.databinding.ActivityUnregisterBinding;
import com.tofly.yxpc.entity.BaseUpdataEntity;
import com.tofly.yxpc.entity.DictEntity;
import com.tofly.yxpc.entity.FileBean;
import com.tofly.yxpc.entity.SbdjEntity;
import com.tofly.yxpc.greenDao.DictEntityDao;
import com.tofly.yxpc.map.LocationUtil_xu;
import com.tofly.yxpc.ui.adapter.BigPictureAdapter;
import com.tofly.yxpc.ui.impl.UpLoadImpl;
import com.tofly.yxpc.utils.DateUtils;
import com.tofly.yxpc.utils.DialogDateUtils;
import com.tofly.yxpc.utils.RecyclerViewUtils;
import com.tofly.yxpc.utils.SpinnerUtils;
import com.tofly.yxpc.utils.db.DaoUtilsStore;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author 76486
 */
public class UnRegisterActivity extends PhotoActivity {
    private BigPictureAdapter adapter;
    private ActivityUnregisterBinding binding;
    private ArrayList<FileBean> phoneList;
    private LocationUtil_xu.CoordinateClass locationUtilXuNew = null;
    private SbdjEntity sbdjEntity;
    private BaseUpdataEntity baseUpdataEntity;
    private List<DictEntity> dictEntities = null;
    private BigPictureAdapter bpPictureAdapter;
    private final List<FileBean> bpPhotoList = new ArrayList<>();
    private int photoType;
    private long id = 0;

    @Override
    public void onTakePhotoSuccess(String pathFile) {
        FileBean fileBean = new FileBean();
        fileBean.setFilePath(pathFile);
        if (photoType == 0) {
            bpPhotoList.add(fileBean);
            bpPictureAdapter.notifyDataSetChanged();
            if (bpPhotoList.isEmpty()) {
                binding.llUnregisterWater.rvListBp.setVisibility(View.GONE);
            } else {
                binding.llUnregisterWater.rvListBp.setVisibility(View.VISIBLE);
            }
        } else {
            phoneList.add(fileBean);
            adapter.setNewData(phoneList);
            if (phoneList.isEmpty()) {
                binding.rvPicture.setVisibility(View.GONE);
            } else {
                binding.rvPicture.setVisibility(View.VISIBLE);
            }
        }
    }

    @Override
    public void onTakeVideoSuccess(String videoFile) {

    }

    @Override
    public Object setLayout() {
        binding = ActivityUnregisterBinding.inflate(getLayoutInflater());
        return binding.getRoot();
    }

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return new UpLoadImpl();
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        setIsLocation(false);
        id = getIntent().getLongExtra("Id", 0);
        setType("2");
        super.onCreate(savedInstanceState);

    }

    @Override
    public void initView() {
        sbdjEntity = DaoUtilsStore.getInstance().getSbdjEntityDbUtils().queryById(id);
        baseUpdataEntity = DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().queryById(id);
        if (sbdjEntity == null) {
            sbdjEntity = new SbdjEntity();
        }
        if (baseUpdataEntity == null) {
            baseUpdataEntity = new BaseUpdataEntity();
        }
        initToolBar(binding.llToolbar.toolbar, binding.llToolbar.tvToolbarTitle, "非在册用水登记");
        phoneList = new ArrayList<>();
        initRecyclerView();
        initLister();
        loadHistory();
    }

    private void initRecyclerView() {
        adapter = new BigPictureAdapter(phoneList, true, filePathBean -> {
        });
        RecyclerViewUtils.initGrid(this, binding.rvPicture, 3, adapter);
    }

    private void initLister() {
        dictEntities = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("noregistered_type"));
        RecyclerViewUtils.initGrid(this, binding.rvPicture, 3, adapter);
        if (phoneList.isEmpty()) {
            binding.rvPicture.setVisibility(View.GONE);
        } else {
            binding.rvPicture.setVisibility(View.VISIBLE);
        }
        if (sbdjEntity.getDescribe() != null) {
            binding.tvDescribe.setText(sbdjEntity.getDescribe());
        }
        initListener();
    }

    private void initListener() {
        binding.imPhone.setOnClickListener(v -> {
            if (phoneList.size() < 9) {
                photoType = 1;
                showPhoto(false);
            } else {
                onMessage("图片数量超过限制");
            }
        });
        binding.llUnregisterWater.imgBpPhoto.setOnClickListener(v -> {
            if (bpPhotoList.size() < 9) {
                photoType = 0;
                showPhoto(false);
            } else {
                onMessage("图片数量超过限制");
            }
        });
        List<DictEntity> dictEntities = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("noregistered_type"));
        for (int i = 0; i < dictEntities.size(); i++) {
            RadioButton radioButton = new RadioButton(this);
            RadioGroup.LayoutParams lp = new RadioGroup.LayoutParams(RadioGroup.LayoutParams.WRAP_CONTENT, RadioGroup.LayoutParams.WRAP_CONTENT);
            //设置RadioButton边距 (int left, int top, int right, int bottom)
            lp.setMargins(10, 0, 0, 0);
            lp.weight = 1;
            //设置RadioButton背景
            //radioButton.setBackgroundResource(R.drawable.xx);
            //设置文字距离四周的距离
            radioButton.setPadding(5, 0, 0, 0);
            //设置文字
            radioButton.setText(dictEntities.get(i).getItemText());
            //设置radioButton的点击事件
            int finalI = i;
            radioButton.setOnCheckedChangeListener((buttonView, isChecked) -> {
                if (isChecked) {
                    sbdjEntity.setType(dictEntities.get(finalI).getId());
                    baseUpdataEntity.setUserName(dictEntities.get(finalI).getItemText());
                    if (dictEntities.get(finalI).getItemText().contains("非在册水表")) {
                        binding.llDzsf.setVisibility(View.VISIBLE);
                        binding.llSbbd.setVisibility(View.VISIBLE);
                        binding.view.setVisibility(View.VISIBLE);
                        binding.llUnregisterWater.llUnregisterWater.setVisibility(View.VISIBLE);
                    } else {
                        binding.llDzsf.setVisibility(View.GONE);
                        binding.llSbbd.setVisibility(View.GONE);
                        binding.view.setVisibility(View.GONE);
                        binding.llUnregisterWater.llUnregisterWater.setVisibility(View.GONE);
                    }
                }
            });
            if (i == 0) {
                binding.rg.check(radioButton.getId());
            }
            //将radioButton添加到radioGroup中
            binding.rg.addView(radioButton, i);
            if (dictEntities.get(i).getItemText().equals(baseUpdataEntity.getUserName())) {
                binding.rg.check(radioButton.getId());
            }
        }
        binding.tvSave.setOnClickListener(v -> {
            if (check()) {
                save();
                saveLocal("保存成功");
            }
        });
        binding.tvUpLoad.setOnClickListener(v -> {
            if (check()) {
                save();
                if (NetworkUtil.isNetworkAvailable()) {
                    updataSbdj();
                } else {
                    saveLocal("网络异常，先保存本地！");
                }
            }
        });
        List<String> brandList = new ArrayList<>();
        List<DictEntity> dictList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("meter_brand"));
        int index = 0;
        for (DictEntity entity : dictList) {
            brandList.add(entity.getItemText());
            if (entity.getId().equals(sbdjEntity.getBrand())) {
                index = dictList.indexOf(entity);
            }
        }
        SpinnerUtils.initSpinner(this, binding.llUnregisterWater.spinnerBrand, brandList);
        List<DictEntity> finalDictList = dictList;
        binding.llUnregisterWater.spinnerBrand.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long aaa) {
                sbdjEntity.setBrand(finalDictList.get(position).getId());
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        binding.llUnregisterWater.spinnerBrand.setSelection(index, true);

        binding.llUnregisterWater.cbBase.setOnClickListener(v -> binding.llUnregisterWater.llBase.setVisibility(binding.llUnregisterWater.cbBase.isChecked() ? View.VISIBLE : View.GONE));
        binding.llUnregisterWater.cbDetail.setOnClickListener(v -> binding.llUnregisterWater.llDetail.setVisibility(binding.llUnregisterWater.cbDetail.isChecked() ? View.VISIBLE : View.GONE));
    }

    private void saveLocal(String message) {
        DaoUtilsStore.getInstance().getSbdjEntityDbUtils().insertOrReplace(sbdjEntity);
        baseUpdataEntity.setId(sbdjEntity.getId());
        baseUpdataEntity.setType(3);
        baseUpdataEntity.setCheckId(AccountManager.getUserId());
        baseUpdataEntity.setExceptionType(sbdjEntity.getType());
        baseUpdataEntity.setDescribe(sbdjEntity.getDescribe());
        baseUpdataEntity.setUserAdd(sbdjEntity.getUserAddr());
        baseUpdataEntity.setSaveTime(DateUtils.getCurrentDate());
        DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().insertOrReplace(baseUpdataEntity);

        onMessage(message);
        finish();
    }

    private void loadHistory() {
        if (sbdjEntity.getFile() != null) {
            phoneList.addAll(sbdjEntity.getFile());
        }
        if (sbdjEntity.getDescribe() != null) {
            binding.tvDescribe.setText(sbdjEntity.getDescribe());
        }
        if (!TextUtils.isEmpty(sbdjEntity.getType()) && dictEntities != null && !dictEntities.isEmpty()) {
            for (int i = 0; i < dictEntities.size(); i++) {
                if (sbdjEntity.getType().equals(dictEntities.get(i).getId())) {
                    RadioButton radioButton = (RadioButton) binding.rg.getChildAt(i);
                    radioButton.setChecked(true);
                }
            }
        }
        adapter.setNewData(phoneList);
        if (phoneList.isEmpty()) {
            binding.rvPicture.setVisibility(View.GONE);
        } else {
            binding.rvPicture.setVisibility(View.VISIBLE);
        }
        List<String> typeList = new ArrayList<>();
        List<DictEntity> dictList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("registered_type"));
        int index = 0;
        for (DictEntity entity : dictList) {
            typeList.add(entity.getItemText());
            if (entity.getId().equals(sbdjEntity.getWaterType())) {
                index = dictList.indexOf(entity);
            }
        }
        SpinnerUtils.initSpinner(this, binding.llUnregisterWater.spinnerWaterType, typeList);
        List<DictEntity> finalDictList3 = dictList;
        binding.llUnregisterWater.spinnerWaterType.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long aaa) {
                sbdjEntity.setWaterType(finalDictList3.get(position).getId());
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        binding.llUnregisterWater.spinnerWaterType.setSelection(index, true);

        List<String> natureList = new ArrayList<>();
        dictList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("water_nature"));
        index = 0;
        for (DictEntity entity : dictList) {
            natureList.add(entity.getItemText());
            if (entity.getId().equals(sbdjEntity.getUseWaterProperties())) {
                index = dictList.indexOf(entity);
            }
        }
        SpinnerUtils.initSpinner(this, binding.llUnregisterWater.spinnerUseWaterProperties, natureList);
        List<DictEntity> finalDictList2 = dictList;
        binding.llUnregisterWater.spinnerUseWaterProperties.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long aaa) {
                sbdjEntity.setUseWaterProperties(finalDictList2.get(position).getId());
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        binding.llUnregisterWater.spinnerUseWaterProperties.setSelection(index, true);

        if (sbdjEntity.getBpFileList() != null) {
            bpPhotoList.addAll(sbdjEntity.getBpFileList());
        }
        bpPictureAdapter = new BigPictureAdapter(bpPhotoList, true, size -> {

        });
        RecyclerViewUtils.initGrid(this, binding.llUnregisterWater.rvListBp, 3, bpPictureAdapter);
        if (bpPhotoList.size() == 0) {
            binding.llUnregisterWater.rvListBp.setVisibility(View.GONE);
        } else {
            binding.llUnregisterWater.rvListBp.setVisibility(View.VISIBLE);
        }

        binding.tvSao.setOnClickListener(view -> {
            IntentIntegrator integrator = new IntentIntegrator(this);
            integrator.setDesiredBarcodeFormats(IntentIntegrator.ALL_CODE_TYPES);
            integrator.setPrompt("请扫码");
            integrator.setCameraId(0);
            integrator.setBeepEnabled(true);
            integrator.setOrientationLocked(false);
            integrator.setCaptureActivity(CaptureActivity.class);
            integrator.initiateScan();
        });

        binding.llUnregisterWater.edInstallTime.setOnTouchListener((view, motionEvent) -> {
            if (MyApp.getInstance().isOverTime()) {
                DialogDateUtils.datePickerDialog(this, binding.llUnregisterWater.edInstallTime.getText().toString(), 2, date -> {
                    binding.llUnregisterWater.edInstallTime.setText(date);
                    sbdjEntity.setInstallTime(date);
                    binding.llUnregisterWater.edInstallTime.setSelection(date.length());
                });
            }
            return false;
        });
        binding.tvDescribe.setText(sbdjEntity.getDescribe() == null ? "" : sbdjEntity.getDescribe());
        binding.edInternetIdCard.setText(sbdjEntity.getInternetIdCard() == null ? "" : sbdjEntity.getInternetIdCard());
        binding.llUnregisterWater.edUserNum.setText(sbdjEntity.getUserNum() == null ? "" : sbdjEntity.getUserNum());
        binding.llUnregisterWater.edUserName.setText(sbdjEntity.getUserName() == null ? "" : sbdjEntity.getUserName());
        binding.llUnregisterWater.edInstallTime.setText(sbdjEntity.getInstallTime() == null ? "" : sbdjEntity.getInstallTime());
        binding.llUnregisterWater.edInstallPosition1.setText(sbdjEntity.getInstallPosition() == null ? "" : sbdjEntity.getInstallPosition());
        binding.llUnregisterWater.edWaterMeterNum.setText(sbdjEntity.getWaterMeterNum() == null ? "" : sbdjEntity.getWaterMeterNum());
        binding.llUnregisterWater.edRecentMark.setText(sbdjEntity.getRecentMark() == null ? "" : sbdjEntity.getRecentMark());
        binding.llUnregisterWater.edQbNum.setText(sbdjEntity.getQbNum() == null ? "" : sbdjEntity.getQbNum());
        binding.llUnregisterWater.edUserAddr.setText(sbdjEntity.getUserAddr() == null ? "" : sbdjEntity.getUserAddr());
        binding.llUnregisterWater.edWaterMeterCaliber.setText(String.valueOf(sbdjEntity.getWaterMeterCaliber()));
        binding.llUnregisterWater.edRecentMark.setText(String.valueOf(sbdjEntity.getRecentMark() == null || "".equals(sbdjEntity.getRecentMark()) ? 0 : sbdjEntity.getRecentMark()));
    }

    private void save() {
        if (sbdjEntity.getId() == null) {
            sbdjEntity.setId(new Date().getTime());
        }
        sbdjEntity.setDescribe(binding.tvDescribe.getText().toString());
        if (locationUtilXuNew != null) {
            sbdjEntity.setLatitude(String.valueOf(locationUtilXuNew.Latitude));
            sbdjEntity.setLongitude(String.valueOf(locationUtilXuNew.Longtitude));
            sbdjEntity.setPosition(locationUtilXuNew.addr);
        }
        sbdjEntity.setCheckId(AccountManager.getUserId());
        sbdjEntity.setFile(phoneList);
        sbdjEntity.setInternetIdCard(binding.edInternetIdCard.getText().toString());
        sbdjEntity.setUserNum(binding.llUnregisterWater.edUserNum.getText().toString());
        sbdjEntity.setUserName(binding.llUnregisterWater.edUserName.getText().toString());
        sbdjEntity.setInstallPosition(binding.llUnregisterWater.edInstallPosition1.getText().toString());
        sbdjEntity.setWaterMeterNum(binding.llUnregisterWater.edWaterMeterNum.getText().toString());
        sbdjEntity.setRecentMark(binding.llUnregisterWater.edRecentMark.getText().toString());
        sbdjEntity.setQbNum(binding.llUnregisterWater.edQbNum.getText().toString());
        sbdjEntity.setUserAddr(binding.llUnregisterWater.edUserAddr.getText().toString());
        if (baseUpdataEntity.getUserName().contains("非在册水表")) {
            sbdjEntity.setBpFileList(bpPhotoList);
        }
        if (binding.llUnregisterWater.edWaterMeterCaliber.getText() != null && !"".equals(binding.llUnregisterWater.edWaterMeterCaliber.getText().toString())) {
            sbdjEntity.setWaterMeterCaliber(Integer.parseInt(binding.llUnregisterWater.edWaterMeterCaliber.getText().toString()));
        }
        if (!TextUtils.isEmpty(binding.llUnregisterWater.edRecentMark.getText())) {
            sbdjEntity.setRecentMark(binding.llUnregisterWater.edRecentMark.getText().toString());
        }
    }

    private void updataSbdj() {
        Map map = JSONObject.parseObject(JSON.toJSONString(sbdjEntity), HashMap.class);
        List<File> files = new ArrayList<>();
        for (FileBean fileBean : sbdjEntity.getFile()) {
            files.add(new File(fileBean.getFilePath()));
        }
        map.put("file", files);
        List<File> files1 = new ArrayList<>();
        if (sbdjEntity.getBpFileList() != null) {
            for (FileBean fileBean : sbdjEntity.getBpFileList()) {
                files1.add(new File(fileBean.getFilePath()));
            }
            map.put("bpFileList", files1);
        }
        mPresenter.getResultOne(this, map);
    }

    private boolean check() {
        if (TextUtils.isEmpty(sbdjEntity.getType())) {
            onMessage("请选择类型");
            return false;
        }
        if (phoneList.size() == 0) {
            onMessage("请添加照片信息");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(binding.llUnregisterWater.edUserNum.getText())) {
            onMessage("请输入用户编号");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(binding.llUnregisterWater.edUserName.getText())) {
            onMessage("请输入用户姓名");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(binding.llUnregisterWater.edWaterMeterNum.getText())) {
            onMessage("请输入水表表号");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(binding.llUnregisterWater.edWaterMeterCaliber.getText())) {
            onMessage("请输入水表口径");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(sbdjEntity.getWaterType())) {
            onMessage("请输选择水表类型");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(sbdjEntity.getBrand())) {
            onMessage("请输选择水表品牌");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && TextUtils.isEmpty(binding.llUnregisterWater.edUserAddr.getText())) {
            onMessage("请输入用户地址");
            return false;
        }
        if (baseUpdataEntity.getUserName().contains("非在册水表") && bpPhotoList.size() == 0) {
            onMessage("请添加表盘照片");
            return false;
        }
        return true;
    }

    @Override
    public void initMapView() {
        super.initMapView();
        aMap.setOnMapTouchListener(motionEvent -> binding.llMap.mapView.requestDisallowInterceptTouchEvent(motionEvent.getAction() != MotionEvent.ACTION_UP));
        aMap.setOnCameraChangeListener(mapCameraChangeListener);
        binding.llMap.imDrag.setVisibility(View.VISIBLE);
        binding.llMap.imgNavit.setVisibility(View.GONE);
        binding.llMap.imgFw.setVisibility(View.GONE);
        binding.llMap.imgAllScreen.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime()) {
                Intent intent = new Intent(this, LocationActivity.class);
                intent.putExtra("locationUtilXuNew", locationUtilXuNew);
                intent.putExtra("isRed", "1");
                intent.putExtra("isDrag", true);
                startActivityForResult(intent, 1105);
            }
        });
        binding.llMap.imgLocation.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime() && lo != null) {
                moveOrigin(lo.Longtitude, lo.Latitude, aMap.getCameraPosition().zoom);
//                aMap.clear();
//                aMap.addMarker(setMark(lo.Longtitude, lo.Latitude, "1"));
                if (!TextUtils.isEmpty(lo.addr)) {
                    binding.llUnregisterWater.edUserAddr.setText(lo.addr);
                }
            }
        });
        binding.llMap.imgMap.setOnClickListener(v -> {
            checkMap();
        });
        if (sbdjEntity.getLongitude() != null && sbdjEntity.getLatitude() != null) {
            locationUtilXuNew = new LocationUtil_xu.CoordinateClass(Double.parseDouble(sbdjEntity.getLongitude())
                    , Double.parseDouble(sbdjEntity.getLatitude()));
            moveOrigin(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, 20);
            if (!TextUtils.isEmpty(locationUtilXuNew.addr)) {
                binding.llUnregisterWater.edUserAddr.setText(locationUtilXuNew.addr == null ? "" : locationUtilXuNew.addr);
            }
        }
    }

    @Override
    public void finishLocation() {
        super.finishLocation();
        if (sbdjEntity != null && sbdjEntity.getLongitude() == null && sbdjEntity.getLatitude() == null) {
            locationUtilXuNew = lo;
            moveOrigin(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, 20);
        }
    }

    @Override
    public void initMapListener(LocationUtil_xu.CoordinateClass info) {
        super.initMapListener(info);
        locationUtilXuNew = info;
        binding.tvLat.setText("经度:" + locationUtilXuNew.Longtitude + " 纬度:" + locationUtilXuNew.Latitude);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 1105 && resultCode == 1106) {
            if (data != null) {
                locationUtilXuNew = (LocationUtil_xu.CoordinateClass) data.getSerializableExtra("locationUtilXuNew");
                if (locationUtilXuNew != null) {
                    moveOrigin(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, aMap.getCameraPosition().zoom);
                    aMap.clear();
//                    aMap.addMarker(setMark(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, "3"));
                    binding.tvLat.setText(locationUtilXuNew.addr);
                }
            }
        } else if (requestCode == 49374 && resultCode == RESULT_OK) {
            IntentResult result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
            if (result != null && result.getContents() != null) {
                binding.edInternetIdCard.setText(result.getContents());
            } else {
                binding.edInternetIdCard.setText("");
            }
        }
    }

    @Override
    public <T> void getResultOne(T response) {
        BaseResponse baseResponse = (BaseResponse) response;
        if (baseResponse != null && "200".equals(baseResponse.getCode())) {
            DaoUtilsStore.getInstance().getSbdjEntityDbUtils().delete(sbdjEntity);
            BaseUpdataEntity baseUpdata = DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().queryById(sbdjEntity.getId());
            DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().delete(baseUpdata);
            onMessage("提交成功");
            finish();
        } else {
            saveLocal("网络异常，先保存本地！");
        }
    }
}
