package com.tofly.yxpc.ui.activity;

import android.text.TextUtils;
import android.view.View;
import android.widget.TextView;

import androidx.appcompat.widget.Toolbar;

import com.tofly.latte_core.base.LatteActivity;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.yxpc.R;
import com.tofly.yxpc.utils.video.JZMediaIjk;
import com.tofly.yxpc.utils.video.MyJzvdStdUtils;

import java.io.File;

import butterknife.BindView;
import cn.jzvd.Jzvd;

/**
 * @author ychk
 * 视频播放
 */
public class VideoActivity extends LatteActivity {

    @BindView(R.id.tv_toolbar_title)
    TextView tvToolbarTitle;
    @BindView(R.id.toolbar)
    Toolbar toolbar;
    @BindView(R.id.jz_video)
    MyJzvdStdUtils jzVideo;

    @Override
    public Object setLayout() {
        return R.layout.activity_video;
    }

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return null;
    }

    @Override
    public void initView() {
        initToolBar(toolbar, tvToolbarTitle, "视频");
        String videoPath = getIntent().getStringExtra("videoPath");
        if (!TextUtils.isEmpty(videoPath)) {
            File file = new File(videoPath);
            if (file.exists()) {
                jzVideo.setUp(videoPath, "", Jzvd.SCREEN_NORMAL, JZMediaIjk.class);
            } else {
                jzVideo.setUp(videoPath, "");
            }
            jzVideo.progressBar.setVisibility(View.GONE);
            jzVideo.fullscreenButton.setVisibility(View.GONE);
            MyJzvdStdUtils.SAVE_PROGRESS = false;
            jzVideo.seekToInAdvance = 0;
            jzVideo.startVideo();
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        MyJzvdStdUtils.goOnPlayOnResume();
    }

    @Override
    protected void onPause() {
        super.onPause();
        MyJzvdStdUtils.goOnPlayOnPause();
    }

    @Override
    public void onBackPressed() {
        if (MyJzvdStdUtils.backPress()) {
            return;
        }
        super.onBackPressed();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        MyJzvdStdUtils.releaseAllVideos();
    }
}
