package com.tofly.yxpc.ui.adapter;

import androidx.annotation.Nullable;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.tofly.yxpc.R;
import com.tofly.yxpc.entity.BaseUpdataEntity;
import com.tofly.yxpc.entity.DictEntity;
import com.tofly.yxpc.greenDao.DictEntityDao;
import com.tofly.yxpc.utils.db.DaoUtilsStore;

import java.util.List;

/**
 * @author 76486
 */
public class DataUpdateAdapter extends BaseQuickAdapter<BaseUpdataEntity, BaseViewHolder> {
    public DataUpdateAdapter(@Nullable List<BaseUpdataEntity> data) {
        super(R.layout.item_data_update, data);
    }

    @Override
    protected void convert(BaseViewHolder helper, BaseUpdataEntity item) {
        switch (item.getType()){
            case 0:
                helper.setBackgroundRes(R.id.img_type, R.mipmap.icon_data_normal);
                helper.setText(R.id.tv_tvname1,"水表表号：");
                helper.setText(R.id.tv_tvname2,"用户地址：");
                helper.setGone(R.id.ll,false);
                helper.setText(R.id.tv_electronic_identity, item.getInternetIdCard() == null ? "" : item.getInternetIdCard());
                helper.setText(R.id.tv_table_number, item.getWaterMeterNum() == null ? "" : item.getWaterMeterNum());
                break;
            case 1:
                helper.setBackgroundRes(R.id.img_type, R.mipmap.icon_data_error);
                helper.setText(R.id.tv_tvname2,"用户地址：");
                helper.setText(R.id.tv_tvname1,"异常类型：");
                helper.setGone(R.id.ll,true);
                helper.setText(R.id.tv_electronic_identity, item.getExceptionType() == null ? "" : item.getExceptionType());
                helper.setText(R.id.tv_table_number, item.getWaterMeterNum() == null ? "" : item.getWaterMeterNum());
                break;
            case 2:
                helper.setBackgroundRes(R.id.img_type, R.mipmap.icon_data_unable);
                helper.setText(R.id.tv_tvname1,"情况类型：");
                helper.setText(R.id.tv_tvname2,"用户地址：");
                helper.setGone(R.id.ll,true);
                helper.setText(R.id.tv_electronic_identity,item.getExceptionType());
                helper.setText(R.id.tv_table_number, item.getWaterMeterNum() == null ? "" : item.getWaterMeterNum());
                break;
            default:
                helper.setBackgroundRes(R.id.img_type, R.mipmap.icon_data_unregister);
                helper.setText(R.id.tv,"描述：");
                helper.setText(R.id.tv_tvname2,"地址：");
                helper.setText(R.id.tv_table_number, item.getDescribe() == null ? "" :  item.getDescribe());
                helper.setText(R.id.tv_electronic_identity, item.getDescribe() == null ? "" :  item.getDescribe());
                helper.setGone(R.id.ll,false);
                break;
        }
        helper.setText(R.id.tv_title,item.getUserName() == null ? "" : item.getUserName());
        helper.setText(R.id.tv_object_type,item.getUserAdd());
        helper.setText(R.id.tv_time, item.getSaveTime() == null ? "" : item.getSaveTime().subSequence(5,item.getSaveTime().length()-3));
    }
}
