package com.tofly.yxpc.ui.adapter;

import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.tofly.yxpc.R;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.greenDao.WaterMeterEntityDao;
import com.tofly.yxpc.utils.db.DaoUtilsStore;
import com.tofly.yxpc.widget.ProgressView;

import java.util.List;

/**
 * @author 76486
 */
public class IndexTaskAdapter extends BaseQuickAdapter<WaterMeterTaskEntity, BaseViewHolder> {
    public IndexTaskAdapter(@Nullable List<WaterMeterTaskEntity> data) {
        super(R.layout.item_index_task, data);
    }

    @Override
    protected void convert(BaseViewHolder helper, WaterMeterTaskEntity item) {
        int total =(int) DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(item.getId()));
        int wks= (int) DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(item.getId()),WaterMeterEntityDao.Properties.State.eq(0));
        int wwc= (int) DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(item.getId()),WaterMeterEntityDao.Properties.State.in(0,1));
        int wsc= (int) DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(item.getId()),WaterMeterEntityDao.Properties.State.eq(2));
        int ywc= (int) DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryCountByQueryBuilder(WaterMeterEntityDao.Properties.TaskId.eq(item.getId()),WaterMeterEntityDao.Properties.State.in(2,3));
       if (total==wks){
           helper.setText(R.id.tv_type,"未开始");
           helper.setBackgroundRes(R.id.tv_type, R.mipmap.icon_data_unstart);
        }else if (total==ywc){
            helper.setText(R.id.tv_type,"已完成");
            helper.setBackgroundRes(R.id.tv_type, R.mipmap.icon_data_finish);
        } else{
           helper.setText(R.id.tv_type,"进行中");
           helper.setBackgroundRes(R.id.tv_type, R.mipmap.icon_data_ongoing);
        }

        helper.setText(R.id.tv_title, item.getTaskName() == null ? "" : item.getTaskName());
        helper.setText(R.id.tv_total_number, String.valueOf(total));
        helper.setText(R.id.tv_complete_number, String.valueOf(wwc));
        if (wsc>0){
            helper.setText(R.id.tv_update_number_no,"待上传"+wsc+"个");
            helper.setGone(R.id.tv_update_number_no,true);
        }else {
            helper.setGone(R.id.tv_update_number_no,false);
        }

        helper.setText(R.id.tv_complete_percent, ywc * 100 / total +"%");

        ProgressView progressView = helper.getView(R.id.progress_view);
        int[] colorList = new int[]{ContextCompat.getColor(mContext, R.color.blue2), ContextCompat.getColor(mContext, R.color.blue2)};
        progressView.setGradientColors(colorList);
        if (total!=0){
            progressView.setValue(ywc*100/total);
        }else {
            progressView.setValue(0);
        }
    }
}
