package com.tofly.yxpc.ui.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentPagerAdapter;

import com.tofly.yxpc.R;
import com.tofly.yxpc.ui.activity.TaskDetailActivity;

import java.util.List;

/**
 * @author 76486
 */
public class ListPageAdapter extends FragmentPagerAdapter {

    private final List<Fragment> fragments;
    private final String[] titles;
    private final int[] ints;
    public ListPageAdapter(FragmentManager fm, String[] titles,int[] ints, List<Fragment> fragments) {
        super(fm);
        this.fragments = fragments;
        this.titles = titles;
        this.ints = ints;
    }

    @Override
    public Fragment getItem(int position) {
        return fragments.get(position);
    }

    @Override
    public int getCount() {
        return fragments.size();
    }

    @Nullable
    @Override
    public CharSequence getPageTitle(int position) {
        return titles[position];
    }
    public View getTabView(int position, Context context){
        View view = LayoutInflater.from(context).inflate(R.layout.item_title,null);
        ImageView iv= view.findViewById(R.id.img_title);
        TextView tv= view.findViewById(R.id.tv_title);
        tv.setText(titles[position]);
        iv.setBackgroundResource(ints[position]);
        return view;
    }
}
