package com.tofly.yxpc.ui.fragment;

import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.MotionEvent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.CheckBox;
import android.widget.LinearLayout;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.zxing.integration.android.IntentIntegrator;
import com.tofly.latte_core.base.LatteContract;
import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.latte_core.utils.AccountManager;
import com.tofly.latte_core.utils.NetworkUtil;
import com.tofly.yxpc.R;
import com.tofly.yxpc.base.MyApp;
import com.tofly.yxpc.databinding.FragmentWaterCheckBinding;
import com.tofly.yxpc.entity.BaseUpdataEntity;
import com.tofly.yxpc.entity.DictEntity;
import com.tofly.yxpc.entity.FileBean;
import com.tofly.yxpc.entity.KbdDescribesBean;
import com.tofly.yxpc.entity.TwdhEntity;
import com.tofly.yxpc.entity.WaterMeterEntity;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.greenDao.DictEntityDao;
import com.tofly.yxpc.greenDao.TwdhEntityDao;
import com.tofly.yxpc.greenDao.WaterMeterTaskEntityDao;
import com.tofly.yxpc.map.LocationUtil_xu;
import com.tofly.yxpc.ui.activity.CaptureActivity;
import com.tofly.yxpc.ui.activity.ImageTextNavitActivity;
import com.tofly.yxpc.ui.activity.LocationActivity;
import com.tofly.yxpc.ui.adapter.BigPictureAdapter;
import com.tofly.yxpc.ui.impl.UpLoadImpl;
import com.tofly.yxpc.utils.DateUtils;
import com.tofly.yxpc.utils.DialogDateUtils;
import com.tofly.yxpc.utils.RecyclerViewUtils;
import com.tofly.yxpc.utils.SpinnerUtils;
import com.tofly.yxpc.utils.db.DaoUtilsStore;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @author 76486
 */
public class WaterCheckFragment extends PhotoFragment {

    private FragmentWaterCheckBinding binding;
    /**
     * 0,表盘照片， 1、照片
     */
    private int photoType = 0;
    private BigPictureAdapter bpPictureAdapter, pictureAdapter;
    private final List<FileBean> bpPhotoList = new ArrayList<>();
    private final List<FileBean> photoList = new ArrayList<>();
    private LocationUtil_xu.CoordinateClass locationUtilXuNew = null;
    private WaterMeterEntity waterMeterEntity;
    private final List<DictEntity> dictEntities = new ArrayList<>();
    private Long navitId = null;


    @Override
    public void onTakePhotoSuccess(String pathFile) {
        FileBean fileBean = new FileBean();
        fileBean.setFilePath(pathFile);
        if (photoType == 0) {
            bpPhotoList.add(fileBean);
            bpPictureAdapter.notifyDataSetChanged();
            if (bpPhotoList.isEmpty()) {
                binding.rvListBp.setVisibility(View.GONE);
            } else {
                binding.rvListBp.setVisibility(View.VISIBLE);
            }
        } else {
            photoList.add(fileBean);
            pictureAdapter.notifyDataSetChanged();
            if (photoList.isEmpty()) {
                binding.rvListPhoto.setVisibility(View.GONE);
            } else {
                binding.rvListPhoto.setVisibility(View.VISIBLE);
            }
        }
    }

    @Override
    public void onTakeVideoSuccess(String videoFile) {

    }

    @Override
    public Object setLayout() {
        binding = FragmentWaterCheckBinding.inflate(getLayoutInflater());
        return binding.getRoot();
    }

    @Override
    protected LatteContract.LattePresenter createPresenter() {
        return new UpLoadImpl();
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        setIsLocation(false);
        super.onCreate(savedInstanceState);
        Bundle bundle = this.getArguments();//得到从Activity传来的数据
        Long Id = null;
        if (bundle != null) {
            Id = bundle.getLong("Id");
        }
        waterMeterEntity = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryById(Id);
    }

    @Override
    public void initView() {
        super.initView();
        initRecyclerView();
        initListener();
        loadData();
    }

    private void initRecyclerView() {
        List<String> brandList = new ArrayList<>();
        List<DictEntity> dictList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("meter_brand"));
        int index = 0;
        if (waterMeterEntity != null) {
            for (DictEntity entity : dictList) {
                brandList.add(entity.getItemText());
                if (entity.getId().equals(waterMeterEntity.getBrand())) {
                    index = dictList.indexOf(entity);
                }
            }
        }
        SpinnerUtils.initSpinner(requireContext(), binding.spinnerBrand, brandList);
        List<DictEntity> finalDictList = dictList;
        binding.spinnerBrand.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long aaa) {
                if (waterMeterEntity != null) {
                    waterMeterEntity.setBrand(finalDictList.get(position).getId());
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        binding.spinnerBrand.setSelection(index, true);

        List<String> typeList = new ArrayList<>();
        dictList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("registered_type"));
        index = 0;
        if (waterMeterEntity != null) {
            for (DictEntity entity : dictList) {
                typeList.add(entity.getItemText());
                if (entity.getId().equals(waterMeterEntity.getType())) {
                    index = dictList.indexOf(entity);
                }
            }
        }
        SpinnerUtils.initSpinner(requireContext(), binding.spinnerWaterType, typeList);
        List<DictEntity> finalDictList3 = dictList;
        binding.spinnerWaterType.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long aaa) {
                if (waterMeterEntity != null) {
                    waterMeterEntity.setType(finalDictList3.get(position).getId());
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        binding.spinnerWaterType.setSelection(index, true);

        List<String> natureList = new ArrayList<>();
        dictList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("water_nature"));
        index = 0;
        if (waterMeterEntity != null) {
            for (DictEntity entity : dictList) {
                natureList.add(entity.getItemText());
                if (entity.getId().equals(waterMeterEntity.getUseWaterProperties())) {
                    index = dictList.indexOf(entity);
                }
            }
        }
        SpinnerUtils.initSpinner(requireContext(), binding.spinnerUseWaterProperties, natureList);
        List<DictEntity> finalDictList2 = dictList;
        binding.spinnerUseWaterProperties.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long aaa) {
                if (waterMeterEntity != null) {
                    waterMeterEntity.setUseWaterProperties(finalDictList2.get(position).getId());
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        binding.spinnerUseWaterProperties.setSelection(index, true);

        if (waterMeterEntity != null && waterMeterEntity.getBpFileList() != null) {
            bpPhotoList.addAll(waterMeterEntity.getBpFileList());
        }
        bpPictureAdapter = new BigPictureAdapter(bpPhotoList, true, size -> {

        });
        RecyclerViewUtils.initGrid(requireContext(), binding.rvListBp, 3, bpPictureAdapter);
        if (bpPhotoList.isEmpty()) {
            binding.rvListBp.setVisibility(View.GONE);
        } else {
            binding.rvListBp.setVisibility(View.VISIBLE);
        }
        if (waterMeterEntity != null && waterMeterEntity.getExceptionFileList() != null) {
            photoList.addAll(waterMeterEntity.getExceptionFileList());
        }
        pictureAdapter = new BigPictureAdapter(photoList, true, size -> {

        });
        RecyclerViewUtils.initGrid(requireContext(), binding.rvListPhoto, 3, pictureAdapter);
        if (photoList.isEmpty()) {
            binding.rvListPhoto.setVisibility(View.GONE);
        } else {
            binding.rvListPhoto.setVisibility(View.VISIBLE);
        }
    }

    private void initListener() {
        binding.imgBpPhoto.setOnClickListener(v -> {
            if (bpPhotoList.size() < 9) {
                photoType = 0;
                showPhoto(false);
            } else {
                onMessage("图片数量超过限制");
            }
        });
        binding.imgPhoto.setOnClickListener(v -> {
            if (photoList.size() < 9) {
                photoType = 1;
                showPhoto(false);
            } else {
                onMessage("图片数量超过限制");
            }
        });
        binding.cbBase.setOnClickListener(v -> binding.llBase.setVisibility(binding.cbBase.isChecked() ? View.VISIBLE : View.GONE));
        binding.cbDetail.setOnClickListener(v -> binding.llDetail.setVisibility(binding.cbDetail.isChecked() ? View.VISIBLE : View.GONE));
        binding.cbAbnormal.setOnClickListener(v -> binding.llAbnormal.setVisibility(binding.cbAbnormal.isChecked() ? View.VISIBLE : View.GONE));
        binding.cbNavit.setOnClickListener(v -> binding.llNavit.setVisibility(binding.cbNavit.isChecked() ? View.VISIBLE : View.GONE));
        binding.tvDraft.setOnClickListener(v -> {
            if (waterMeterEntity != null) {
                save();
                waterMeterEntity.setState(1);
                DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().insertOrReplace(waterMeterEntity);
                BaseUpdataEntity baseUpdata = DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().queryById(waterMeterEntity.getId());
                if (baseUpdata != null) {
                    DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().delete(baseUpdata);
                }
                onMessage("保存成功");
                requireActivity().finish();
            }
        });
//        GeocodeSearch geocodeSearch = new GeocodeSearch(getContext());
//        geocodeSearch.setOnGeocodeSearchListener(new GeocodeSearch.OnGeocodeSearchListener() {
//            @Override
//            public void onRegeocodeSearched(RegeocodeResult regeocodeResult, int i) {
//
//            }
//
//            @Override
//            public void onGeocodeSearched(GeocodeResult geocodeResult, int i) {
//                if (i == 1000) {
//                    if (geocodeResult != null && geocodeResult.getGeocodeAddressList() != null && !geocodeResult.getGeocodeAddressList().isEmpty()) {
//                        GeocodeAddress geocodeAddress = geocodeResult.getGeocodeAddressList().get(0);
//                        double longitude = geocodeAddress.getLatLonPoint().getLongitude();
//                        double latitude = geocodeAddress.getLatLonPoint().getLatitude();
//                        LocationUtil_xu.CoordinateClass lo = new LocationUtil_xu.CoordinateClass(longitude, latitude);
//                        moveOrigin(lo.Longtitude, lo.Latitude, 20);
//                    }
//                }
//            }
//        });

//        binding.edInstallPosition.addTextChangedListener(new TextWatcher() {
//            @Override
//            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
//
//            }
//
//            @Override
//            public void onTextChanged(CharSequence s, int start, int before, int count) {
//
//            }
//
//            @Override
//            public void afterTextChanged(Editable s) {
//                if (!TextUtils.isEmpty(s)) {
//                    GeocodeQuery query = new GeocodeQuery(s.toString(), null);
//                    geocodeSearch.getFromLocationNameAsyn(query);
//                }
//            }
//        });

        binding.tvSave.setOnClickListener(v -> {
            if (check()) {
                save();
                saveLocal("保存成功");
            }
        });
        binding.tvSubmit.setOnClickListener(v -> {
            if (check()) {
                save();
                if (NetworkUtil.isNetworkAvailable()) {
                    updataWaterMeter();
                } else {
                    saveLocal("网络异常，先保存本地");
                }
            }
        });

        binding.tvSee.setOnClickListener(v -> {
            if (waterMeterEntity != null) {
                Intent intent = new Intent(getContext(), ImageTextNavitActivity.class);
                intent.putExtra("id", String.valueOf(navitId));
                startActivity(intent);
            }
        });
        binding.tvNew.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime() && waterMeterEntity != null) {
                Intent intent = new Intent(requireActivity(), ImageTextNavitActivity.class);
                intent.putExtra("waterMeterId", waterMeterEntity.getId());
                startActivityForResult(intent, 1102);
            }
        });
        binding.tvSao.setOnClickListener(view -> {
            IntentIntegrator integrator = new IntentIntegrator(requireActivity());
            integrator.setDesiredBarcodeFormats(IntentIntegrator.ALL_CODE_TYPES);
            integrator.setPrompt("请扫码");
            integrator.setCameraId(0);
            integrator.setBeepEnabled(true);
            integrator.setOrientationLocked(false);
            integrator.setCaptureActivity(CaptureActivity.class);
            integrator.initiateScan();
        });
    }

    private void loadData() {
        if (waterMeterEntity != null) {
            binding.edInstallTime.setText(waterMeterEntity.getInstallTime() == null ? "" : waterMeterEntity.getInstallTime());
            TwdhEntity twdhEntity = DaoUtilsStore.getInstance().getTwdhEntityDbUtils().queryByQueryBuilderOne(TwdhEntityDao.Properties.WaterNavigationInspects.like("%" + waterMeterEntity.getId() + "%"));
            initNavit(twdhEntity);
            binding.edInternetIdCard.setText(waterMeterEntity.getInternetIdCard() == null ? "" : waterMeterEntity.getInternetIdCard());
            binding.edInstallPosition.setText("经度:" + waterMeterEntity.getLongitude() + " 纬度:" + waterMeterEntity.getLatitude());
            if (!TextUtils.isEmpty(waterMeterEntity.getLongitude()) && !TextUtils.isEmpty(waterMeterEntity.getLatitude())) {
                locationUtilXuNew = new LocationUtil_xu.CoordinateClass(Double.parseDouble(waterMeterEntity.getLongitude()), Double.parseDouble(waterMeterEntity.getLatitude()), "");
            }
            binding.tvUserNum.setText(waterMeterEntity.getUserNum() == null ? "" : waterMeterEntity.getUserNum());
            binding.tvUserName.setText(waterMeterEntity.getUserName() == null ? "" : waterMeterEntity.getUserName());
            binding.edWaterMeterNum.setText(waterMeterEntity.getWaterMeterNum() == null ? "" : waterMeterEntity.getWaterMeterNum());
            binding.edQbNum.setText(waterMeterEntity.getQbNum() == null ? "" : waterMeterEntity.getQbNum());
            binding.edUserAddr.setText(waterMeterEntity.getUserAddr() == null ? "" : waterMeterEntity.getUserAddr());
            binding.edRecentMark.setText(waterMeterEntity.getRecentMark() == null ? "" : waterMeterEntity.getRecentMark());
            binding.edWaterMeterCaliber.setText(String.valueOf(waterMeterEntity.getWaterMeterCaliber()));
            if (waterMeterEntity.getKbdDescribes() != null && waterMeterEntity.getKbdDescribes().getExceptionDescribe() != null) {
                binding.edDescribe.setText(waterMeterEntity.getKbdDescribes().getExceptionDescribe());
            } else {
                binding.edDescribe.setText("");
            }
            binding.edInstallPosition1.setText(waterMeterEntity.getInstallPosition() == null ? "" : waterMeterEntity.getInstallPosition());
            List<DictEntity> dictEntityList = DaoUtilsStore.getInstance().getDictEntityDbUtils().queryByQueryBuilder(DictEntityDao.Properties.DictCode.eq("abnormal_info"));
            List<String> ides = null;
            if (waterMeterEntity.getKbdDescribes() != null && waterMeterEntity.getKbdDescribes().getExceptionType() != null) {
                ides = new ArrayList<>(Arrays.asList(waterMeterEntity.getKbdDescribes().getExceptionType().split(",")));
            }

            for (DictEntity dictEntity : dictEntityList) {
                CheckBox checkBox = new CheckBox(requireContext());
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                    checkBox.setTextColor(getContext().getColor(R.color.color_333));
                    LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);
                    //设置边距
                    layoutParams.setMargins(20, 12, 0, 0);
                    //将以上的属性赋给LinearLayout
                    checkBox.setLayoutParams(layoutParams);
                    checkBox.setTextSize(16);
                }
                checkBox.setText(dictEntity.getItemText());
                checkBox.setOnCheckedChangeListener((buttonView, isChecked) -> {
                    if (isChecked) {
                        dictEntities.add(dictEntity);
                    } else {
                        dictEntities.remove(dictEntity);
                    }
                });
                if (ides != null && ides.contains(dictEntity.getId())) {
                    checkBox.setChecked(true);
                }
                binding.llAbnormal.addView(checkBox, dictEntityList.indexOf(dictEntity));
            }

            binding.edInstallTime.setOnTouchListener((view, motionEvent) -> {
                if (MyApp.getInstance().isOverTime()) {
                    DialogDateUtils.datePickerDialog(getContext(), binding.edInstallTime.getText().toString(), 2, date -> {
                        binding.edInstallTime.setText(date);
                        waterMeterEntity.setInstallTime(date);
                        binding.edInstallTime.setSelection(date.length());
                    });
                }
                return false;
            });
            if (waterMeterEntity.getState() == 3) {
                binding.layout.setVisibility(View.GONE);
            } else {
                binding.layout.setVisibility(View.VISIBLE);
            }
        }
    }

    private void initNavit(TwdhEntity twdhEntity) {
        List<TwdhEntity> twdhEntityList = DaoUtilsStore.getInstance().getTwdhEntityDbUtils().queryAll();
        List<String> stringList = new ArrayList<>();
        List<Long> longList = new ArrayList<>();
        stringList.add("请选择");
        for (TwdhEntity twdh : twdhEntityList) {
            stringList.add(twdh.getName() == null ? "" : twdh.getName());
            longList.add(twdh.getId());
        }
        SpinnerUtils.initSpinner(requireContext(), binding.spinnerNavit, stringList);
        binding.spinnerNavit.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                position--;
                if (position == -1) {
                    navitId = null;
                    binding.tvSee.setVisibility(View.GONE);
                } else {
                    navitId = twdhEntityList.get(position).getId();
                    binding.tvSee.setVisibility(View.VISIBLE);
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
        if (!twdhEntityList.isEmpty() && twdhEntity != null) {
            int index = longList.indexOf(twdhEntity.getId()) + 1;
            if (index > 1) {
                binding.spinnerNavit.setSelection(index);
            }
        }
    }

    private void saveLocal(String message) {
        waterMeterEntity.setState(2);
        DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().insertOrReplace(waterMeterEntity);
        BaseUpdataEntity baseUpdataEntity = DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().queryById(waterMeterEntity.getId());
        if (baseUpdataEntity == null) {
            baseUpdataEntity = new BaseUpdataEntity();
        }
        baseUpdataEntity.setId(waterMeterEntity.getId());
        baseUpdataEntity.setCheckId(AccountManager.getUserId());
        baseUpdataEntity.setUserName(waterMeterEntity.getUserName());
        baseUpdataEntity.setInternetIdCard(waterMeterEntity.getInternetIdCard());
        if (waterMeterEntity.getKbdDescribes() == null) {
            baseUpdataEntity.setType(0);
        } else {
            baseUpdataEntity.setType(1);
            StringBuilder stringBuilder = new StringBuilder();
            for (DictEntity entity : dictEntities) {
                if (dictEntities.indexOf(entity) == 0) {
                    stringBuilder.append(entity.getItemText());
                } else {
                    stringBuilder.append(",").append(entity.getItemText());
                }
            }
            baseUpdataEntity.setExceptionType(stringBuilder.toString());
        }
        baseUpdataEntity.setWaterMeterNum(waterMeterEntity.getWaterMeterNum());
        baseUpdataEntity.setSaveTime(DateUtils.getCurrentDate());
        baseUpdataEntity.setUserAdd(waterMeterEntity.getUserAddr());
        DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().insertOrReplace(baseUpdataEntity);

        onMessage(message);
        requireActivity().finish();
    }

    private void updataWaterMeter() {
        updateTwdh();

        Map map = JSONObject.parseObject(JSON.toJSONString(waterMeterEntity), HashMap.class);
        List<File> files1 = new ArrayList<>();
        for (FileBean fileBean : waterMeterEntity.getBpFileList()) {
            files1.add(new File(fileBean.getFilePath()));
        }
        map.put("bpFileList", files1);
        List<File> files2 = new ArrayList<>();
        if (waterMeterEntity.getExceptionFileList() != null) {
            for (FileBean fileBean : waterMeterEntity.getExceptionFileList()) {
                files2.add(new File(fileBean.getFilePath()));
            }
        }
        map.put("exceptionFileList", files2);

        List<File> files3 = new ArrayList<>();
        if (waterMeterEntity.getWfbdFileList() != null) {
            for (FileBean fileBean : waterMeterEntity.getWfbdFileList()) {
                files3.add(new File(fileBean.getFilePath()));
            }
        }
        map.put("wfbdFileList", files3);
        mPresenter.getResultThree(requireContext(), map);
    }

    /**
     * 上传本地绑定未上传的图文导航
     */
    private void updateTwdh() {
        if (!TextUtils.isEmpty(waterMeterEntity.getNavigationId())) {
            TwdhEntity twdhEntity = DaoUtilsStore.getInstance().getTwdhEntityDbUtils().queryById(Long.parseLong(waterMeterEntity.getNavigationId()));
            if (twdhEntity != null && "0".equals(twdhEntity.getState())) {
                Map<String, Object> map = new HashMap<>();
                map.put("id", twdhEntity.getId());
                map.put("name", twdhEntity.getName());
                map.put("describe", twdhEntity.getDescribe());
                map.put("waterNavigationInspects", twdhEntity.getWaterNavigationInspects());
                if (twdhEntity.getFileList() != null && !twdhEntity.getFileList().isEmpty()) {
                    List<File> files = new ArrayList<>();
                    for (FileBean fileBean : twdhEntity.getFileList()) {
                        files.add(new File(fileBean.getFilePath()));
                    }
                    map.put("file", files);
                }
                List<File> dtFiles = new ArrayList<>();
                for (FileBean fileBean : twdhEntity.getMapFileList()) {
                    dtFiles.add(new File(fileBean.getFilePath()));
                }
                map.put("mapfilelist", dtFiles);
                mPresenter.getResultTwo(requireContext(), map);
            }
        }
    }

    private void save() {
        if (locationUtilXuNew != null) {
            waterMeterEntity.setLongitude(String.valueOf(locationUtilXuNew.Longtitude));
            waterMeterEntity.setLatitude(String.valueOf(locationUtilXuNew.Latitude));
        }
        waterMeterEntity.setInternetIdCard(binding.edInternetIdCard.getText().toString());
        waterMeterEntity.setInstallPosition(binding.edInstallPosition1.getText().toString());
        waterMeterEntity.setWaterMeterNum(binding.edWaterMeterNum.getText().toString());
        waterMeterEntity.setRecentMark(binding.edRecentMark.getText().toString());
        waterMeterEntity.setQbNum(binding.edQbNum.getText().toString());
        waterMeterEntity.setUserAddr(binding.edUserAddr.getText().toString());
        waterMeterEntity.setBpFileList(bpPhotoList);
        waterMeterEntity.setNavigationId(navitId == null ? "" : String.valueOf(navitId));
        if (!TextUtils.isEmpty(binding.edWaterMeterCaliber.getText().toString())) {
            waterMeterEntity.setWaterMeterCaliber(Integer.parseInt(binding.edWaterMeterCaliber.getText().toString()));
        }
        if (!TextUtils.isEmpty(binding.edRecentMark.getText())) {
            waterMeterEntity.setRecentMark(binding.edRecentMark.getText().toString());
        }
        if (!TextUtils.isEmpty(binding.edDescribe.getText().toString())) {
            if (waterMeterEntity.getKbdDescribes() == null) {
                KbdDescribesBean kbdDescribesBean = new KbdDescribesBean();
                waterMeterEntity.setKbdDescribes(kbdDescribesBean);
            }
            waterMeterEntity.getKbdDescribes().setExceptionDescribe(binding.edDescribe.getText().toString());
        }
        waterMeterEntity.setExceptionFileList(photoList);

        if (!dictEntities.isEmpty()) {
            StringBuilder stringBuilder = new StringBuilder();
            if (waterMeterEntity.getKbdDescribes() == null) {
                KbdDescribesBean kbdDescribesBean = new KbdDescribesBean();
                waterMeterEntity.setKbdDescribes(kbdDescribesBean);
            }
            for (DictEntity entity : dictEntities) {
                if (dictEntities.indexOf(entity) == 0) {
                    stringBuilder.append(entity.getId());
                } else {
                    stringBuilder.append(",").append(entity.getId());
                }
            }
            waterMeterEntity.getKbdDescribes().setExceptionType(stringBuilder.toString());
        }
        waterMeterEntity.setWfDescribes(null);
        waterMeterEntity.setWfbdFileList(null);
    }

    private boolean check() {
        if (TextUtils.isEmpty(binding.edDescribe.getText()) && waterMeterEntity.getKbdDescribes() != null && waterMeterEntity.getKbdDescribes().getExceptionType() == null) {
            waterMeterEntity.setKbdDescribes(null);
        }
        if (TextUtils.isEmpty(binding.edWaterMeterCaliber.getText())) {
            onMessage("请输入水表口径");
            return false;
        }
        if (Integer.parseInt(binding.edWaterMeterCaliber.getText().toString()) > 10000 || Integer.parseInt(binding.edWaterMeterCaliber.getText().toString()) < 0) {
            onMessage("请输入正确水表口径");
            return false;
        }
        if (TextUtils.isEmpty(binding.edUserAddr.getText())) {
            onMessage("请输入用户地址");
            return false;
        }
        if (bpPhotoList.isEmpty()) {
            onMessage("请添加表盘照片");
            return false;
        }
        return true;
    }

    public void setQc(@NonNull String qc) {
        binding.edInternetIdCard.setText(qc);
    }

    @Override
    public void initMapView() {
        super.initMapView();
        aMap.setOnMapTouchListener(motionEvent -> binding.llMap.mapView.requestDisallowInterceptTouchEvent(motionEvent.getAction() != MotionEvent.ACTION_UP));
        setIsRed(true);
        aMap.setOnCameraChangeListener(mapCameraChangeListener);
        binding.llMap.imDrag.setVisibility(View.VISIBLE);
        binding.llMap.imgNavit.setVisibility(View.GONE);
        binding.llMap.imgFw.setVisibility(View.GONE);
        binding.llMap.imgAllScreen.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime()) {
                Intent intent = new Intent(requireContext(), LocationActivity.class);
                intent.putExtra("locationUtilXuNew", locationUtilXuNew);
                intent.putExtra("isRed", "1");
                intent.putExtra("isDrag", true);
                startActivityForResult(intent, 1105);
            }
        });
        binding.llMap.imgLocation.setOnClickListener(v -> {
            if (MyApp.getInstance().isOverTime() && lo != null) {
                moveOrigin(lo.Longtitude, lo.Latitude, aMap.getCameraPosition().zoom);
                if (!TextUtils.isEmpty(lo.addr)) {
                    binding.edUserAddr.setText(lo.addr);
                }
            }
        });
        binding.llMap.imgMap.setOnClickListener(v -> {
            checkMap();
        });
        if (waterMeterEntity != null && waterMeterEntity.getLatitude() != null && waterMeterEntity.getLongitude() != null) {
            locationUtilXuNew = new LocationUtil_xu.CoordinateClass(Double.parseDouble(waterMeterEntity.getLongitude())
                    , Double.parseDouble(waterMeterEntity.getLatitude()), waterMeterEntity.getUserAddr());
            moveOrigin(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, 20);
            if (!TextUtils.isEmpty(locationUtilXuNew.addr)) {
                binding.edUserAddr.setText(locationUtilXuNew.addr);
            }
        }
    }

    @Override
    public void finishLocation() {
        super.finishLocation();
        if (locationUtilXuNew == null) {
            locationUtilXuNew = lo;
            moveOrigin(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, 20);
        }
    }

    @Override
    public void initMapListener(LocationUtil_xu.CoordinateClass info) {
        super.initMapListener(info);
        locationUtilXuNew = info;
        binding.edInstallPosition.setText("经度:" + locationUtilXuNew.Longtitude + " 纬度:" + locationUtilXuNew.Latitude);
        if (!TextUtils.isEmpty(locationUtilXuNew.addr)) {
            binding.edUserAddr.setText(locationUtilXuNew.addr);
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 1102 && resultCode == 0) {
            TwdhEntity twdhEntity = DaoUtilsStore.getInstance().getTwdhEntityDbUtils().queryByQueryBuilderOne(TwdhEntityDao.Properties.WaterNavigationInspects.like("%" + waterMeterEntity.getId() + "%"));
            navitId = twdhEntity.getId();
            waterMeterEntity.setNavigationId(String.valueOf(navitId));
            DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().insertOrReplace(waterMeterEntity);
            if (twdhEntity != null) {
                initNavit(twdhEntity);
            } else {
                binding.tvSee.setVisibility(View.GONE);
            }
        } else if (requestCode == 1105 && resultCode == 1106) {
            if (data != null) {
                locationUtilXuNew = (LocationUtil_xu.CoordinateClass) data.getSerializableExtra("locationUtilXuNew");
                if (locationUtilXuNew != null) {
                    moveOrigin(locationUtilXuNew.Longtitude, locationUtilXuNew.Latitude, aMap.getCameraPosition().zoom);
                    binding.edInstallPosition.setText("经度:" + locationUtilXuNew.Longtitude + " 纬度:" + locationUtilXuNew.Latitude);
                    if (!TextUtils.isEmpty(locationUtilXuNew.addr)) {
                        binding.edUserAddr.setText(locationUtilXuNew.addr);
                    }
                }
            }
        }
    }

    @Override
    public <T> void getResultOne(T response) {

    }

    @Override
    public <T> void getResultTwo(T response) {
        BaseResponse baseResponse = (BaseResponse) response;
        if (baseResponse != null && "200".equals(baseResponse.getCode())) {
            TwdhEntity twdhEntity = DaoUtilsStore.getInstance().getTwdhEntityDbUtils().queryById(Long.parseLong(waterMeterEntity.getNavigationId()));
            if (twdhEntity != null) {
                twdhEntity.setState(null);
                new Thread(() -> {
                    String[] id = twdhEntity.getWaterNavigationInspects().split(",");
                    for (String str : id) {
                        if (!TextUtils.isEmpty(str)) {
                            List<TwdhEntity> twdhEntityList = DaoUtilsStore.getInstance().getTwdhEntityDbUtils().queryByQueryBuilder(TwdhEntityDao.Properties.WaterNavigationInspects.like("%" + str + "%"));
                            for (TwdhEntity entity1 : twdhEntityList) {
                                String waterNavigationInspects = entity1.getWaterNavigationInspects().replace("," + str, "").replace(str, "");
                                entity1.setWaterNavigationInspects(waterNavigationInspects);
                                if (TextUtils.isEmpty(entity1.getWaterNavigationInspects())) {
                                    DaoUtilsStore.getInstance().getTwdhEntityDbUtils().delete(entity1);
                                } else {
                                    DaoUtilsStore.getInstance().getTwdhEntityDbUtils().insertOrReplace(entity1);
                                }
                            }
                        }
                    }
                    DaoUtilsStore.getInstance().getTwdhEntityDbUtils().insertOrReplace(twdhEntity);
                }).start();
            }
        }
    }

    @Override
    public <T> void getResultThree(T response) {
        BaseResponse baseResponse = (BaseResponse) response;
        if (baseResponse != null && "200".equals(baseResponse.getCode())) {
            waterMeterEntity.setState(3);
            DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().insertOrReplace(waterMeterEntity);
            BaseUpdataEntity baseUpdata = DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().queryById(waterMeterEntity.getId());
            if (baseUpdata != null) {
                DaoUtilsStore.getInstance().getBaseUpdataEntityDbUtils().delete(baseUpdata);
            }
            List<WaterMeterTaskEntity> waterMeterTaskEntities = DaoUtilsStore.getInstance().getWaterMeterTaskEntityDbUtils().queryByQueryBuilder(WaterMeterTaskEntityDao.Properties.CheckUser.eq(AccountManager.getUserId()));
            for (WaterMeterTaskEntity entity : waterMeterTaskEntities) {
                boolean flag = true;
                for (WaterMeterEntity waterMeter : entity.getYxswWaterMeterInspectDto()) {
                    WaterMeterEntity dbWaterMeter = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryById(waterMeter.getId());
                    waterMeter.setState(dbWaterMeter.getState());
                    if (3 != dbWaterMeter.getState()) {
                        flag = false;
                    }
                }
                if (flag) {
                    entity.setState("2");
                }
            }
            DaoUtilsStore.getInstance().getWaterMeterTaskEntityDbUtils().insertMulti(waterMeterTaskEntities, false);
            onMessage("数据上传完毕");
            requireActivity().finish();
        } else {
            saveLocal("上传失败，先保存本地");
        }
    }
}
