package com.tofly.yxpc.ui.impl;


import android.content.Context;

import com.alibaba.fastjson.JSON;
import com.tofly.latte_core.base.LattePresenterImpl;
import com.tofly.latte_core.net.LatteNetWorkApi;
import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.latte_core.net.helper.RxHelper;
import com.tofly.latte_core.net.observer.BaseObserver;
import com.tofly.yxpc.base.Api;
import com.tofly.yxpc.entity.DictEntity;
import com.tofly.yxpc.entity.TwdhEntity;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.utils.RequestBodyUtils;

import java.util.List;
import java.util.Map;

/**
 * @author ychk
 */
public class MainImpl extends LattePresenterImpl {

    @Override
    public void getResultOne(Context context, Map<String, Object> map) {
        super.getResultOne(context, map);
        LatteNetWorkApi.getApiService(Api.class)
                .getdictItem(RequestBodyUtils.toRequestBodyJson(JSON.toJSONString(map)))
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new BaseObserver<List<DictEntity>>() {
                    @Override
                    public void onSuccess(List<DictEntity> demo) {
                        if (isViewAttached()) {
                            getView().getResultOne(demo);
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                        }
                    }
                });
    }

    @Override
    public void getResultTwo(Context context, Map<String, Object> map) {
        super.getResultTwo(context, map);
        LatteNetWorkApi.getApiService(Api.class)
                .getWaterTwNavigation(RequestBodyUtils.toRequestBodyJson(JSON.toJSONString(map)))
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new BaseObserver<BaseResponse<List<TwdhEntity>>>() {
                    @Override
                    public void onSuccess(BaseResponse<List<TwdhEntity>> demo) {
                        if (isViewAttached()) {
                            if ("200".equals(demo.getCode())) {
                                getView().getResultTwo(demo.getData());
                            }
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                        }
                    }
                });
    }

    @Override
    public void getResultThree(Context context, Map<String, Object> map) {
        super.getResultThree(context, map);
        LatteNetWorkApi.getApiService(Api.class)
                .taskDownload((String) map.get("userId"))
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new BaseObserver<BaseResponse<List<WaterMeterTaskEntity>>>() {
                    @Override
                    public void onSuccess(BaseResponse<List<WaterMeterTaskEntity>> demo) {
                        if (isViewAttached()) {
                            getView().getResultThree(demo.getData());
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                            getView().hideLoading();
                        }
                    }
                });
    }
}
