package com.tofly.yxpc.ui.impl;

import android.content.Context;

import com.tofly.latte_core.base.LattePresenterImpl;
import com.tofly.latte_core.config.Constants;
import com.tofly.latte_core.net.LatteNetWorkApi;
import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.latte_core.net.helper.RxHelper;
import com.tofly.latte_core.net.observer.BaseObserver;
import com.tofly.latte_core.net.observer.MyObserver;
import com.tofly.yxpc.base.Api;
import com.tofly.yxpc.entity.user.UserInfo;

import java.util.HashMap;
import java.util.Map;

import okhttp3.RequestBody;

/**
 * @author ychk
 */
public class MyImpl extends LattePresenterImpl {


    @Override
    public void getResultTwo(Context context, Map<String, Object> map) {
        super.getResultTwo(context, map);
        LatteNetWorkApi.getApiService(Api.class)
                .getUserInfo()
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new BaseObserver<UserInfo>() {
                    @Override
                    public void onSuccess(UserInfo demo) {
                        if (isViewAttached()) {
                            getView().getResultTwo(demo);
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                        }
                    }
                });
    }
}
