package com.tofly.yxpc.ui.impl;

import android.content.Context;

import com.alibaba.fastjson.JSON;
import com.tofly.latte_core.base.LattePresenterImpl;
import com.tofly.latte_core.config.Constants;
import com.tofly.latte_core.net.LatteNetWorkApi;
import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.latte_core.net.helper.RxHelper;
import com.tofly.latte_core.net.observer.MyObserver;
import com.tofly.yxpc.base.Api;
import com.tofly.yxpc.entity.base.FileResponse;
import com.tofly.yxpc.utils.RequestBodyUtils;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

import okhttp3.RequestBody;

/**
 * @author 76486
 */
public class SettingImpl extends LattePresenterImpl {

    @Override
    public void getResultOne(Context context, Map<String, Object> map) {
        super.getResultOne(context, map);
        Map<String, RequestBody> params = new HashMap<>();
        for (String k : map.keySet()) {
            params.put(k, (RequestBody) map.get(k));
        }
        LatteNetWorkApi.getApiService(Api.class)
                .submitFile(params)
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new MyObserver<FileResponse>(context) {
                    @Override
                    public void onSuccess(FileResponse demo) {
                        if (isViewAttached()) {
                            if (demo.getCode() == null || Constants.SUCCESS.equals(demo.getCode())) {
                                getView().getResultOne(demo);
                            } else {
                                getView().onMessage(demo.getMessage());
                                getView().getResultOne(null);
                            }
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                            getView().getResultOne(null);
                        }
                    }
                });
    }

    @Override
    public void getResultTwo(Context context, Map<String, Object> map) {
        super.getResultTwo(context, map);
        LatteNetWorkApi.getApiService(Api.class)
                .updateUser(RequestBodyUtils.toRequestBodyJson(JSON.toJSONString(map)))
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new MyObserver<BaseResponse>(context) {
                    @Override
                    public void onSuccess(BaseResponse demo) {
                        if (isViewAttached()) {
                            if (demo.getCode() == null || Constants.SUCCESS.equals(demo.getCode())) {
                                getView().getResultTwo(1);
                            } else {
                                getView().onMessage(demo.getMessage());
                                getView().getResultTwo(null);
                            }
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                            getView().getResultTwo(null);
                        }
                    }
                });
    }

    @Override
    public void getResultThree(Context context, Map<String, Object> map) {
        super.getResultThree(context, map);
        LatteNetWorkApi.getApiService(Api.class)
                .resetPwd(RequestBodyUtils.toRequestBodyJson(JSON.toJSONString(map)))
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new MyObserver<BaseResponse>(context) {
                    @Override
                    public void onSuccess(BaseResponse demo) {
                        if (isViewAttached()) {
                            if (Objects.equals(demo.getCode(), Constants.SUCCESS)) {
                                getView().getResultThree(demo.getCode());
                            } else {
                                getView().onMessage(demo.getMessage());
                                getView().getResultThree(null);
                            }
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                            getView().getResultThree(null);
                        }
                    }
                });
    }
}
