package com.tofly.yxpc.ui.impl;

import android.content.Context;

import com.alibaba.fastjson.JSONObject;
import com.tofly.latte_core.base.LattePresenterImpl;
import com.tofly.latte_core.net.LatteNetWorkApi;
import com.tofly.latte_core.net.bean.BaseResponse;
import com.tofly.latte_core.net.helper.RxHelper;
import com.tofly.latte_core.net.observer.MyObserver;
import com.tofly.yxpc.base.Api;
import com.tofly.yxpc.utils.RequestBodyUtils;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import io.reactivex.Observable;
import okhttp3.MultipartBody;
import okhttp3.RequestBody;

public class UpLoadImpl extends LattePresenterImpl {
    @Override
    public void getResultOne(Context context, Map<String, Object> map) {
        super.getResultOne(context, map);
        List<MultipartBody.Part> parts1 = new ArrayList<>();
        List<File> list1 = (List<File>) map.get("file");
        if (list1 != null && list1.size() > 0) {
            for (int i = 0; i < list1.size(); i++) {
                MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("file", list1.get(i), context);
                parts1.add(part);
            }
            map.remove("file");
        }
        List<MultipartBody.Part> parts2 = new ArrayList<>();
        List<File> list2 = (List<File>) map.get("bpFileList");
        if (list2 != null && list2.size() > 0) {
            parts2 = new ArrayList<>();
            for (int i = 0; i < list2.size(); i++) {
                MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("bpfilelist", list2.get(i), context);
                parts2.add(part);
            }
            map.remove("bpFileList");
        }
        Map<String, RequestBody> params = new HashMap<>();
        for (Map.Entry<String, Object> entry : map.entrySet()) {
            String key = entry.getKey();
            Object value = entry.getValue();
            params.put(key, RequestBodyUtils.toRequestBodyString(value==null?"":value.toString()));
        }
      Api api =  LatteNetWorkApi.getApiService(Api.class);
        Observable<BaseResponse> observable;
         if(list2 == null || list2.size() == 0){
             observable=  api.uploadWaterNotInspect(parts1,params);
         }else {
             observable= api.uploadWaterNotInspect(parts1,parts2,params);
         }
        observable.compose(RxHelper.observableIO2Main(context))
                .subscribe(new MyObserver<BaseResponse>(context) {
                    @Override
                    public void onSuccess(BaseResponse demo) {
                        if (isViewAttached()) {
                            getView().getResultOne(demo);
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            BaseResponse baseResponse = new BaseResponse();
                            baseResponse.setCode(null);
                            baseResponse.setMessage(errorMsg);
                            getView().getResultThree(baseResponse);
                        }
                    }
                });
    }

    @Override
    public void getResultTwo(Context context, Map<String, Object> map) {
        super.getResultTwo(context, map);

        List<MultipartBody.Part> parts1 = new ArrayList<>();
        List<File> list1 = (List<File>) map.get("mapfilelist");
        if (list1 != null && list1.size() > 0) {
            for (int i = 0; i < list1.size(); i++) {
                MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("mapfilelist", list1.get(i), context);
                parts1.add(part);
            }
            map.remove("mapfilelist");
        }

        List<MultipartBody.Part> parts2 = new ArrayList<>();
        List<File> list2 = (List<File>) map.get("file");
        if (list2 != null && list2.size() > 0) {
            for (int i = 0; i < list2.size(); i++) {
                MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("file", list2.get(i), context);
                parts2.add(part);
            }
            map.remove("file");
        }
        Map<String, RequestBody> params = new HashMap<>();
        for (Map.Entry<String, Object> entry : map.entrySet()) {
            String key = entry.getKey();
            Object value = entry.getValue();
            params.put(key, RequestBodyUtils.toRequestBodyString(value.toString()));
        }
        LatteNetWorkApi.getApiService(Api.class)
                .uploadWaterTwNavigation(params,parts1,parts2)
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new MyObserver<BaseResponse>(context) {
                    @Override
                    public void onSuccess(BaseResponse demo) {
                        if (isViewAttached()) {
                            getView().getResultTwo(demo);
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            getView().onMessage(errorMsg);
                        }
                    }
                });
    }

    @Override
    public void getResultThree(Context context, Map<String, Object> map) {
        super.getResultThree(context, map);

        List<MultipartBody.Part> parts1 = new ArrayList<>();
        List<File> list1 = (List<File>) map.get("bpFileList");
        if (list1 != null && list1.size() > 0) {
            for (int i = 0; i < list1.size(); i++) {
                    MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("bpFileList", list1.get(i), context);
                    parts1.add(part);
            }
            map.remove("bpFileList");
        }

        List<MultipartBody.Part> parts2 = new ArrayList<>();
        List<File> list2 = (List<File>) map.get("exceptionFileList");
        if (list2 != null && list2.size() > 0) {
            for (int i = 0; i < list2.size(); i++) {
                MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("exceptionFileList", list2.get(i), context);
                parts2.add(part);
            }
            map.remove("exceptionFileList");
        }

        List<MultipartBody.Part> parts3 = new ArrayList<>();
        List<File> list3 = (List<File>) map.get("wfbdFileList");
        if (list3 != null && list3.size() > 0) {
            for (int i = 0; i < list3.size(); i++) {
                MultipartBody.Part part = RequestBodyUtils.toMultiPartBodyFile("wfbdFileList", list3.get(i), context);
                parts3.add(part);
            }
            map.remove("wfbdFileList");
        }

        Map<String, RequestBody> params = new HashMap<>();
        for (Map.Entry<String, Object> entry : map.entrySet()) {
            String key = entry.getKey();
            if (key.equals("kbdDescribes")||key.equals("wfDescribes")){
                JSONObject value = (JSONObject) entry.getValue();
                if(value.get("exceptionType")!=null){
                    params.put(key+".exceptionType", RequestBodyUtils.toRequestBodyString(value.get("exceptionType").toString()));
                }
                if (value.get("exceptionDescribe")!=null){
                    params.put(key+".exceptionDescribe", RequestBodyUtils.toRequestBodyString(value.get("exceptionDescribe").toString()));
                }
            }else {
                Object value = entry.getValue();
                params.put(key, RequestBodyUtils.toRequestBodyString(value.toString()));
            }
        }
          LatteNetWorkApi.getApiService(Api.class)
                .updateBatchByCus(params,parts1,parts2,parts3)
                .compose(RxHelper.observableIO2Main(context))
                .subscribe(new MyObserver<BaseResponse>(context) {
                    @Override
                    public void onSuccess(BaseResponse demo) {
                        if (isViewAttached()) {
                            getView().getResultThree(demo);
                        }
                    }

                    @Override
                    public void onFailure(Throwable e, String errorMsg) {
                        if (isViewAttached()) {
                            BaseResponse baseResponse = new BaseResponse();
                            baseResponse.setCode(null);
                            baseResponse.setMessage(errorMsg);
                            getView().getResultThree(baseResponse);
                        }
                    }
                });
    }
}
