package com.tofly.yxpc.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import static java.util.regex.Pattern.compile;

/**
 * @author ychk
 */
public class CheckPhoneUtils {

    /**
     * 方法名： isPhoneNum
     * 功能：校验手机号码有效性
     * 参数： phoneNum 手机号码
     * 返回值:true:有效;false:无效
     * 异常：
     */
    public static boolean isPhoneNum(String phoneNum) {
        if (phoneNum.length() != 11) {
            return false;
        }
        Pattern p = compile("^(13[0-9]|14[0-9]|15[0-9]|17[0-9]|18[0-9]|19[0-9])\\d{8}$");
        Matcher m = p.matcher(phoneNum);
        return m.matches();

    }

    /**
     * 方法名： isEmail
     * 功能：校验电子邮箱有效性
     * 参数： email 电子邮箱
     * 返回值:true:有效;false:无效
     * 异常：
     */
    public static boolean isEmail(String email) {
        Pattern pattern = compile("^([a-zA-Z0-9_\\-\\.]+)@((\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.)|(([a-zA-Z0-9\\-]+\\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\\]?)$");
        Matcher m = pattern.matcher(email);
        return m.matches();
    }
}
