package com.tofly.yxpc.utils;

import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.Context;
import android.text.TextUtils;
import android.view.WindowManager;
import android.widget.DatePicker;

import androidx.appcompat.app.AlertDialog;

import com.tofly.yxpc.R;
import com.tofly.yxpc.base.MyApp;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * @author ychk
 */
public class DialogDateUtils {
    /**
     * @param type 0,不禁用时间点击，1禁用今天之前的时间，2禁用今天之后的时间
     */
    public static void datePickerDialogSF(Context mContext, String textDateStart, int type, Listeners listeners) {
        String time;
        if (TextUtils.isEmpty(textDateStart)) {
            time = DateUtils.getYMD();
        } else {
            time = textDateStart;
        }
        String date = time.split(" ")[0];
        String times = time.split(" ")[1];
        int[] dateArray = DateUtils.getYMDArray(date, "-");
        int year = dateArray[0];
        int month = dateArray[1] - 1;
        int day = dateArray[2];
        int[] timeArray = DateUtils.getYMDArray(times, ":");
        int hour = timeArray[0];
        int minut = timeArray[1];

        DatePickerDialog datePickerDialog = new DatePickerDialog(mContext, R.style.dialog_date, (view, year1, monthOfYear, dayOfMonth) -> {
            TimePickerDialog timePickerDialog = new TimePickerDialog(mContext, android.R.style.Theme_Holo_Light_Dialog_NoActionBar, (view1, hourOfDay, minute) -> {
                GregorianCalendar dateSet = new GregorianCalendar(year1, monthOfYear, dayOfMonth, hourOfDay, minute);
                listeners.onFinish(DateUtils.getDateTime(dateSet.getTime().getTime()));
            }, hour, minut, true);
            timePickerDialog.setTitle("设置时间");
            timePickerDialog.show();
        }, year, month, day);
        long timedate = System.currentTimeMillis();
        DatePicker datePicker = datePickerDialog.getDatePicker();
        switch (type) {
            case 1:
                datePicker.setMinDate(timedate);
                break;
            case 2:
                datePicker.setMaxDate(timedate);
                break;
            default:
                break;
        }

        datePickerDialog.show();
    }

    /**
     * @param type 0,不禁用时间点击，1禁用今天之前的时间，2禁用今天之后的时间
     */
    public static void datePickerDialog(Context mContext, String textDateStart, int type, Listeners listeners) {
        String time;
        if (TextUtils.isEmpty(textDateStart)) {
            time = DateUtils.getYMD();
        } else {
            time = textDateStart;
        }
        String date = time.split(" ")[0];
        int[] dateArray = DateUtils.getYMDArray(date, "-");
        int year = dateArray[0];
        int month = dateArray[1] - 1;
        int day = dateArray[2];
        DatePickerDialog datePickerDialog = new DatePickerDialog(mContext, R.style.dialog_date, (view, year1, monthOfYear, dayOfMonth) -> {
            GregorianCalendar dateSet = new GregorianCalendar(year1, monthOfYear, dayOfMonth);
            listeners.onFinish(DateUtils.getDate(dateSet.getTime().getTime()));
        }, year, month, day);
        long timedate = System.currentTimeMillis();
        DatePicker datePicker = datePickerDialog.getDatePicker();
        switch (type) {
            case 1:
                datePicker.setMinDate(timedate);
                break;
            case 2:
                datePicker.setMaxDate(timedate);
                break;
            default:
                break;
        }

        datePickerDialog.show();
    }

    /**
     * 获取间隔多少天后的时间
     */
    public static void datePickerDialog(Context mContext, String textDateStart, int type, String startTime, int invoperion, Listeners listeners) {
        String time;
        if (TextUtils.isEmpty(textDateStart)) {
            time = DateUtils.getYMD();
        } else {
            time = textDateStart;
        }
        String date = time.split(" ")[0];
        int[] dateArray = DateUtils.getYMDArray(date, "-");
        int year = dateArray[0];
        int month = dateArray[1] - 1;
        int day = dateArray[2];
        DatePickerDialog datePickerDialog = new DatePickerDialog(mContext, R.style.dialog_date, (view, year1, monthOfYear, dayOfMonth) -> {
            GregorianCalendar dateSet = new GregorianCalendar(year1, monthOfYear, dayOfMonth);
            listeners.onFinish(DateUtils.getDate(dateSet.getTime().getTime()));
        }, year, month, day);
        Calendar calendar = DateUtils.getCalenderFromYMD(startTime);
        calendar.add(Calendar.DAY_OF_YEAR, invoperion);
        long timedate = calendar.getTime().getTime();
        DatePicker datePicker = datePickerDialog.getDatePicker();
        switch (type) {
            case 1:
                datePicker.setMinDate(timedate);
                break;
            case 2:
                datePicker.setMaxDate(timedate);
                break;
            default:
                break;
        }

        datePickerDialog.show();
    }


    public interface Listeners {
        void onFinish(String time);
    }

    /**
     * 时间前后禁用
     */
    public static void datePickerDialogSFM(Context mContext, String textDateEnd, String sTime, int type, Listeners listeners) {
        String time;
        if (TextUtils.isEmpty(textDateEnd)) {
            time = DateUtils.getDate();
        } else {
            time = textDateEnd;
        }
        String[] date = time.split(" ");
        int[] dateArray = DateUtils.getYMDArray(date[0], "-");
        int year = dateArray[0];
        int month = dateArray[1] - 1;
        int day = dateArray[2];
        String[] timArray = date[1].split(":");
        String hour = timArray[0] + ":" + timArray[1];

        DatePickerDialog datePickerDialog = new DatePickerDialog(mContext, R.style.dialog_date, (view, year1, monthOfYear, dayOfMonth) -> {
            GregorianCalendar dateSet = new GregorianCalendar(year1, monthOfYear, dayOfMonth);
            String dateTime = DateUtils.getDate(dateSet.getTime().getTime());
            List<String> list = getHours();
            List<String> arrayList = new ArrayList<>();
            if (!TextUtils.isEmpty(textDateEnd) && !TextUtils.isEmpty(sTime)) {
                if (dateTime.equals(sTime.split(" ")[0])) {
                    String[] oldTimeArray = sTime.split(" ")[1].split(":");
                    String newHour = oldTimeArray[0] + ":" + oldTimeArray[1];
                    int position = list.indexOf(newHour);
                    int length = list.size();
                    for (int i = 0; i < length; i++) {
                        if (i > position) {
                            arrayList.add(list.get(i));
                        }
                    }
                } else {
                    arrayList.addAll(list);
                }
            } else {
                arrayList.addAll(list);
            }
            showDialogHour(mContext, hour, dateTime, arrayList, listeners);
        }, year, month, day);
        Calendar calendar = DateUtils.getCalenderFromTime(sTime);
        calendar.add(Calendar.DAY_OF_YEAR, 0);
        long timedate = calendar.getTime().getTime();
        DatePicker datePicker = datePickerDialog.getDatePicker();
        switch (type) {
            case 1:
                datePicker.setMinDate(timedate);
                break;
            case 2:
                datePicker.setMaxDate(timedate);
                break;
            default:
                break;
        }
        datePickerDialog.show();
    }

    /**
     * 小时选择
     */
    private static void showDialogHour(Context context, String hour, String dateTime, List<String> list, Listeners listeners) {
        final String[] items = list.toArray(new String[0]);
        AtomicInteger mSelection = new AtomicInteger();
        if (!TextUtils.isEmpty(hour)) {
            mSelection.set(list.indexOf(hour));
        } else {
            mSelection.set(0);
        }
        AlertDialog alertDialog = new AlertDialog.Builder(context, R.style.AlertDialog).
                setTitle("选择时间")
                .setSingleChoiceItems(items, mSelection.get(), (dialog, which) -> mSelection.set(which))
                .setCancelable(true)
                .setNegativeButton("取消", null)
                .setPositiveButton("确认", (dialog, which) -> {
                    if (mSelection.get() > -1) {
                        listeners.onFinish(dateTime + " " + items[mSelection.get()] + ":00");
                        dialog.dismiss();
                    }
                }).create();
        alertDialog.show();
        WindowManager.LayoutParams params = alertDialog.getWindow().getAttributes();
        params.width = MyApp.dip2px(300);
        params.height = MyApp.dip2px(400);
        alertDialog.getWindow().setAttributes(params);
    }

    /**
     * 获取小时时间列表
     */
    private static List<String> getHours() {
        List<String> strings = new ArrayList<>();
        strings.add("00:00");
        strings.add("01:00");
        strings.add("02:00");
        strings.add("03:00");
        strings.add("04:00");
        strings.add("05:00");
        strings.add("06:00");
        strings.add("07:00");
        strings.add("08:00");
        strings.add("09:00");
        strings.add("10:00");
        strings.add("11:00");
        strings.add("12:00");
        strings.add("13:00");
        strings.add("14:00");
        strings.add("15:00");
        strings.add("16:00");
        strings.add("17:00");
        strings.add("18:00");
        strings.add("19:00");
        strings.add("20:00");
        strings.add("21:00");
        strings.add("22:00");
        strings.add("23:00");
        return strings;
    }
}
