package com.tofly.yxpc.utils;

import android.content.Context;
import android.content.DialogInterface;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.TextView;

import androidx.appcompat.app.AlertDialog;
import com.tofly.yxpc.R;
import java.util.Objects;

/**
 * @author ychk
 */
public class DialogUtils {

    /**
     * 普查对话框
     */
    public static void showDialog(Context context, String title, String message, boolean cancelable, final DialogInterface.OnClickListener listener) {
        AlertDialog.Builder builder = new AlertDialog.Builder(context, R.style.dialog);
        View view = LayoutInflater.from(context).inflate(R.layout.dialog_simaple, null);
        builder.setView(view)
                .setCancelable(cancelable);
        final AlertDialog dialog = builder.create();
        dialog.show();
        WindowManager.LayoutParams layoutParams = Objects.requireNonNull(dialog.getWindow()).getAttributes();
        layoutParams.gravity = Gravity.CENTER;
        layoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;
        layoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
        dialog.getWindow().getDecorView().setPadding(0, 0, 0, 0);
        TextView tvTitle = view.findViewById(R.id.tv_title);
        if (!TextUtils.isEmpty(title)) {
            tvTitle.setText(title);
            tvTitle.setVisibility(View.VISIBLE);
        }
        TextView tvContent = view.findViewById(R.id.tv_content);
        if (!TextUtils.isEmpty(message)) {
            tvContent.setText(message);
            tvContent.setVisibility(View.VISIBLE);
        }
        TextView tvCancel = view.findViewById(R.id.btn_cancel);
        TextView tvOk = view.findViewById(R.id.btn_ok);
        tvCancel.setOnClickListener(v -> dialog.dismiss());
        tvOk.setOnClickListener(v -> {
            dialog.dismiss();
            listener.onClick(null, 0);
        });
    }

}
