package com.tofly.yxpc.utils;

import android.app.Dialog;
import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Window;
import android.view.WindowManager;
import android.widget.EditText;

import androidx.annotation.NonNull;

import com.tofly.yxpc.R;
import com.tofly.yxpc.entity.WaterMeterEntity;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.greenDao.WaterMeterEntityDao;
import com.tofly.yxpc.utils.db.DaoUtilsStore;

import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;


/**
 * 二维码弹出框
 * Created by wt
 */
public class DialogWater extends Dialog {
    private DialogWaterAdapter adapter;
    private Context mContext;
    private List<WaterMeterEntity> waterMeterEntities;

    public DialogWater(@NonNull Context context, MyOnClick myOnClick) {
        super(context, R.style.dialog);
        mContext = context;
        setContentView(LayoutInflater.from(mContext).inflate(R.layout.dialog_water, null));
        Window window = getWindow();
        DisplayMetrics dm = new DisplayMetrics();
        window.getWindowManager().getDefaultDisplay().getMetrics(dm);
        WindowManager.LayoutParams params = window.getAttributes();
        params.width = dm.widthPixels - 200;
        params.height = dm.densityDpi + 500;
        params.gravity = Gravity.CENTER;
        window.setAttributes(params);
        setCancelable(true);
        setCanceledOnTouchOutside(true);
        EditText editText = findViewById(R.id.ed_num);
        waterMeterEntities = new ArrayList<>();
        Set<Long> taskIds = new LinkedHashSet<>();
        List<WaterMeterTaskEntity> waterMeterTaskEntityList = DaoUtilsStore.getInstance().getWaterMeterTaskEntityDbUtils().queryAll();
        for (WaterMeterTaskEntity taskEntity : waterMeterTaskEntityList) {
            if (taskIds.add(taskEntity.getId())) {
                waterMeterEntities.addAll(DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryByQueryBuilderAndOr(WaterMeterEntityDao.Properties.TaskId.eq(taskEntity.getId()),
                        WaterMeterEntityDao.Properties.State.eq(0), WaterMeterEntityDao.Properties.State.eq(1), WaterMeterEntityDao.Properties.State.eq(2)));
            }
        }
        adapter = new DialogWaterAdapter(waterMeterEntities);
        RecyclerViewUtils.initLinerV(mContext, findViewById(R.id.rv_list), adapter, true, 0);
        editText.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (s == null) {
                    waterMeterEntities = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryAll();
                } else {
                    waterMeterEntities = DaoUtilsStore.getInstance().getWaterMeterEntityDbUtils().queryByQueryBuilderOr(
                            WaterMeterEntityDao.Properties.WaterMeterNum.like("%" + s + "%"),
                            WaterMeterEntityDao.Properties.UserNum.like("%" + s + "%"),
                            WaterMeterEntityDao.Properties.UserName.like("%" + s + "%"),
                            WaterMeterEntityDao.Properties.UserAddr.like("%" + s + "%"));
                }
                adapter.setNewData(waterMeterEntities);
            }
        });
        findViewById(R.id.tv_ok).setOnClickListener(view -> {
            String ids = "";
            String nums = "";
            for (WaterMeterEntity entity : waterMeterEntities) {
                if (entity.isIscheck()) {
                    ids += entity.getId() + ",";
                    nums += entity.getWaterMeterNum() + ",";
                }
            }
            myOnClick.sure(ids.substring(0, ids.length() - 1), nums.substring(0, nums.length() - 1));
            dismiss();
        });
        findViewById(R.id.tv_cancel).setOnClickListener(view -> dismiss());
        findViewById(R.id.all).setOnClickListener(view -> {
            for (WaterMeterEntity waterMeter : waterMeterEntities) {
                waterMeter.setIscheck(true);
            }
            adapter.setNewData(waterMeterEntities);
        });
    }

    public interface MyOnClick {
        void sure(String ids, String nums);
    }
}
