package com.tofly.yxpc.utils;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import com.tofly.yxpc.ui.activity.BigImageActivity;
import java.lang.ref.WeakReference;
import java.util.ArrayList;

/**
 * @author ychk
 */
public class ImageUtil {
    private ArrayList<String> mPicList1;
    private ArrayList<String> mPicList2;
    private WeakReference<Context> weakReference;
    public static final String PICS_PATH_KEY = "pics_path";
    private int cameraType = 1;
    public ImageUtil(Context context) {
        weakReference = new WeakReference<>(context);
    }

    public void showBigImage(String filepath, boolean isWhite) {
        Bundle mBundle = new Bundle();
        if (cameraType == 1) {
            if (mPicList1 == null) {
                mPicList1 = new ArrayList<>();
            } else {
                mPicList1.clear();
            }
            mPicList1.add(filepath);

            mBundle.putStringArrayList(PICS_PATH_KEY, mPicList1);
        } else {
            if (mPicList2 == null) {
                mPicList2 = new ArrayList<>();
            } else {
                mPicList2.clear();
            }
            mPicList2.add(filepath);
            mBundle.putStringArrayList(PICS_PATH_KEY, mPicList2);
        }

        Intent intent = new Intent(weakReference.get(), BigImageActivity.class);
        intent.putExtras(mBundle);
        intent.putExtra("isWhite", isWhite);
        weakReference.get().startActivity(intent);
    }

}
