package com.tofly.yxpc.utils;

import android.content.Context;
import android.media.MediaPlayer;
import android.util.Log;

import java.io.IOException;

/**
 * @author ychk
 */
public class MP3Player {

    private MediaPlayer mp;
    private String path;
    private int length;
    private String oldPath = "";


    public MP3Player(Context ctx) {
        mp = new MediaPlayer();
    }

    public int getPosition() {
        // 获取当前位置
        return mp.getCurrentPosition();
    }

    public int getLength() {
        return length;
    }

    public void init(String fileName) {
        path = fileName;
        try {

            if (mp.isPlaying()) {
                //判断当前的地址是不是正在播放的地址 如果是就暂停  如果不是  切换播放
                if (oldPath.equals(path)) {
                    stop();
                } else {
                    //避免多次点击闪退
                    goOnPlay();
                }

            } else {
                //避免多次点击闪退
                goOnPlay();
            }
            oldPath = path;
        } catch (IOException e) {
            e.printStackTrace();
            Log.e("tf", "---init Error---" + e.getMessage());
        }
    }

    public void initInternetUrl(String fileName) {
        path = fileName;
        try {
            if (mp.isPlaying()) {

                //判断当前的地址是不是正在播放的地址 如果是就暂停  如果不是  切换播放
                if (oldPath.equals(path)) {
                    stop();
                } else {
                    //避免多次点击闪退
                    goOnPlay();
                }
            } else {
                goOnPlay();
            }
            oldPath = path;
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void goOnPlay() throws IOException {
        //避免多次点击闪退
        mp.reset();
        // 存储在SD卡或其他文件路径下的媒体文件
        mp.setDataSource(path);
        // 音乐文件准备
        mp.prepare();
        // 音乐文件长度
        length = mp.getDuration();
    }

    public boolean isPlaying() {
        return mp.isPlaying();
    }

    public void play() {
        mp.start();
    }

    public void pause() {
        mp.pause();
    }

    public void stop() {
        mp.stop();
    }

    public void destroy() {
        mp.release();
    }

    public void setToPosition(int position) {
        mp.seekTo(position);
    }

    public void changStatus() {

        if (mp.isPlaying()) {
            mp.pause();
            return;
        }
        mp.start();

    }
}
