package com.tofly.yxpc.utils;

import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.tofly.yxpc.R;

/**
 * @author 76486
 */
public class RecyclerViewUtils {

    @SuppressLint("MissingInflatedId")
    public static void initLinerV(Context context, RecyclerView recyclerView, BaseQuickAdapter adapter, boolean isEmpty,int type) {
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(context);
        linearLayoutManager.setOrientation(RecyclerView.VERTICAL);
        recyclerView.setLayoutManager(linearLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.setAdapter(adapter);
        if (isEmpty) {
            View view =LayoutInflater.from(context).inflate(R.layout.view_empty, null, false);
            if (type==1){
                view.findViewById(R.id.img).setBackgroundResource(R.mipmap.icon_empty1);
                ((TextView)view.findViewById(R.id.tv)).setText("数据已上传");
            }else {
                view.findViewById(R.id.img).setBackgroundResource(R.mipmap.icon_empty);
                ((TextView)view.findViewById(R.id.tv)).setText("暂无数据");
            }
            adapter.setEmptyView(view);
        }
    }

    public static void initLinerH(Context context, RecyclerView recyclerView, BaseQuickAdapter adapter, boolean isEmpty,int type) {
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(context);
        linearLayoutManager.setOrientation(RecyclerView.HORIZONTAL);
        recyclerView.setLayoutManager(linearLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.setAdapter(adapter);
        if (isEmpty) {
            View view =LayoutInflater.from(context).inflate(R.layout.view_empty, null, false);
            if (type==1){
                view.findViewById(R.id.img).setBackgroundResource(R.mipmap.icon_empty1);
            }else {
                view.findViewById(R.id.img).setBackgroundResource(R.mipmap.icon_empty);
            }
            adapter.setEmptyView(view);
        }
    }

    public static void initGrid(Context context, RecyclerView recyclerView, int count, BaseQuickAdapter adapter) {
        GridLayoutManager linearLayoutManager = new GridLayoutManager(context, count);
        linearLayoutManager.setOrientation(RecyclerView.VERTICAL);
        recyclerView.setLayoutManager(linearLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.setAdapter(adapter);
    }
}
