package com.tofly.yxpc.utils.db;

import com.tofly.yxpc.base.MyApp;
import com.tofly.yxpc.entity.BaseUpdataEntity;
import com.tofly.yxpc.entity.DictEntity;
import com.tofly.yxpc.entity.SbdjEntity;
import com.tofly.yxpc.entity.TwdhEntity;
import com.tofly.yxpc.entity.UserEntity;
import com.tofly.yxpc.entity.WaterMeterEntity;
import com.tofly.yxpc.entity.WaterMeterTaskEntity;
import com.tofly.yxpc.greenDao.DaoSession;

import org.greenrobot.greendao.AbstractDao;

/**
 * 存放DbUtils
 * @author 76486
 */
public class DaoUtilsStore {
    private DaoSession mSession;

    private static class DaoHolder {
        private volatile static DaoUtilsStore INSTANCE = new DaoUtilsStore();
    }

    public static DaoUtilsStore getInstance() {
        return DaoHolder.INSTANCE;
    }

    @SuppressWarnings("unchecked")
    private DaoUtilsStore() {
        mSession = MyApp.getInstance().getDaoSession();
    }

    public <T> AbstractDao getTableDao(Class<T> entityClass) {
        AbstractDao dao = mSession.getDao(entityClass);
        return dao;
    }

    public DbUtils<UserEntity> getUserEntityDbUtils() {
        return new DbUtils(UserEntity.class, mSession.getUserEntityDao());
    }
    public DbUtils<TwdhEntity> getTwdhEntityDbUtils() {
        return new DbUtils(TwdhEntity.class, mSession.getTwdhEntityDao());
    }
    public DbUtils<SbdjEntity> getSbdjEntityDbUtils() {
        return new DbUtils(SbdjEntity.class, mSession.getSbdjEntityDao());
    }
    public DbUtils<WaterMeterTaskEntity> getWaterMeterTaskEntityDbUtils() {
        return new DbUtils(WaterMeterTaskEntity.class, mSession.getWaterMeterTaskEntityDao());
    }
    public DbUtils<WaterMeterEntity> getWaterMeterEntityDbUtils() {
        return new DbUtils(WaterMeterEntity.class, mSession.getWaterMeterEntityDao());
    }
    public DbUtils<DictEntity> getDictEntityDbUtils() {
        return new DbUtils(DictEntity.class, mSession.getDictEntityDao());
    }
    public DbUtils<BaseUpdataEntity> getBaseUpdataEntityDbUtils() {
        return new DbUtils(BaseUpdataEntity.class, mSession.getBaseUpdataEntityDao());
    }
}
