package com.tofly.yxpc.utils.update;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.widget.DialogTitle;


import com.tofly.yxpc.R;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * @author ychk
 */
public class VersionUpdateHintDialog extends Dialog {
    @BindView(R.id.alertTitle)
    DialogTitle alertTitle;
    @BindView(R.id.main_hint_text)
    TextView textMainHint;
    @BindView(R.id.text_version_name)
    TextView textVersionName;
    @BindView(R.id.text_publish_time)
    TextView textPublishTime;
    @BindView(R.id.text_version_desc)
    TextView textVersionDesc;
    @BindView(android.R.id.button2)
    Button button2;
    @BindView(android.R.id.button1)
    Button button1;

    private Context mContext;
    private VersionInfo.VersionBean mVersionUpdate;
    private View.OnClickListener onConfirm, onCancel;

    public VersionUpdateHintDialog(@NonNull Context context, VersionInfo.VersionBean versionInfo,
                                   View.OnClickListener clickListener, View.OnClickListener clickListener1) {
        super(context, R.style.AlertDialog);
        mContext = context;
        mVersionUpdate = versionInfo;
        onConfirm = clickListener;
        onCancel = clickListener1;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.dialog_version_update_hint);
        ButterKnife.bind(this);
        this.setCancelable(false);
        this.setCanceledOnTouchOutside(false);
        Window dialogWindow = getWindow();
        if (dialogWindow != null) {
            dialogWindow.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM);
            dialogWindow.setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_VISIBLE);
            dialogWindow = getWindow();
            WindowManager.LayoutParams lp = dialogWindow.getAttributes();
            DisplayMetrics d = mContext.getResources().getDisplayMetrics(); // 获取屏幕宽、高用
            dialogWindow.setAttributes(lp);
        }
        initData();
    }

    private void initData() {
        button1.setText("更新");
        button2.setText(android.R.string.cancel);
        if (mVersionUpdate != null) {
            textVersionName.setText(mVersionUpdate.getVersionNumber());
            textPublishTime.setText(mVersionUpdate.getCreateTime());
            textVersionDesc.setText(mVersionUpdate.getDetail());
            button2.setText("下次再说");
            String message = "软件有更新，请下载安装。";
/*            if (isMustUpdate)
                message = "软件更新后才可继续使用，是否现在更新？";*/
            textMainHint.setText(message);
        }
    }

    @OnClick({android.R.id.button1, android.R.id.button2})
    public void onClick(View view) {
        switch (view.getId()) {
            /*Button OK*/
            case android.R.id.button1:
                if (onConfirm != null) {
                    onConfirm.onClick(view);
                }
                dismiss();
                break;
            case android.R.id.button2:
                if (onCancel != null) {
                    onCancel.onClick(view);
                }
                dismiss();
                break;
            default:
                break;
        }
    }
}
