package com.tofly.yxpc.utils.video;

import android.content.Context;
import android.media.MediaMetadataRetriever;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import com.hw.videoprocessor.VideoProcessor;
import com.tofly.latte_core.config.Constants;

import java.io.File;

/**
 * 创建日期：2022/9/19 16:19
 *
 * @author YeJavon
 * @version 1.0
 * 包名： com.tofly.dewater.utils
 * 类说明：
 */
public class VideoProcessorUtils {

    private static long start;
    private static long end;

    private static final int BITRATE_DEFAULT = 1000000;

    private static final int FRAME_RATE = 16;

    public static void compressVideo2(Context context, String oldPath, Handler.Callback callback) {

        String compressPath = Constants.VIDEO_PATH + System.currentTimeMillis() + ".mp4";
        new Thread(() -> {
            boolean success = true;
            try {
                MediaMetadataRetriever retriever = new MediaMetadataRetriever();
                retriever.setDataSource(oldPath);
                int originWidth = Integer.parseInt(retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_VIDEO_WIDTH));
                int originHeight = Integer.parseInt(retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_VIDEO_HEIGHT));
                int bitrate = Integer.parseInt(retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_BITRATE));
                //double frameRate = Double.parseDouble(retriever.extractMetadata(MediaMetadataRetriever.METADATA_KEY_CAPTURE_FRAMERATE));

                int outWidth = 1280;
                int outHeight = 720;
                start = System.currentTimeMillis();
                VideoProcessor.processor(context)
                        .input(oldPath)
                        .outWidth(outWidth)
                        .outHeight(outHeight)
                        .output(compressPath)
                        .bitrate(BITRATE_DEFAULT)//这个属性不加,有些小视频反而越压缩越大
                        .frameRate(FRAME_RATE)
                        //以下参数全部为可选
//                        .outWidth(outWidth)
//                        .outHeight(outHeight)
//                            .startTimeMs(startTimeMs)//用于剪辑视频
//                            .endTimeMs(endTimeMs)    //用于剪辑视频
//                            .speed(speed)            //改变视频速率，用于快慢放
//                            .changeAudioSpeed(changeAudioSpeed) //改变视频速率时，音频是否同步变化
//                            .bitrate(bitrate)       //输出视频比特率
//                            .frameRate(frameRate)   //帧率
//                            .iFrameInterval(iFrameInterval)  //关键帧距，为0时可输出全关键帧视频（部分机器上需为-1）
//                            .progressListener(listener)      //可输出视频处理进度
                        .process();
            } catch (Exception e) {
                success = false;
                e.printStackTrace();
            }
            Message message = Message.obtain();
            if (success) {
                end = System.currentTimeMillis();
                Log.e("aaa", "压缩耗时：" + (end - start) / 1000 + "秒");
                Log.e("aaa", "视频压缩后大小：" + new File(compressPath).length() / 1024 / 1024 + "MB");
                Log.e("aaa", "视频大小：" + new File(oldPath).length() / 1024 / 1024 + "MB");
                message.obj = compressPath;
                File file = new File(oldPath);
                if (file.exists()) {
                    file.delete();
                }
            } else {
                message.obj = null;
            }
            callback.handleMessage(message);
        }).start();
    }
}
