package com.tofly.latte_core.base;

import com.tofly.latte_core.config.Constants;
import com.tofly.latte_core.net.bean.BaseResponse;

import io.reactivex.ObservableTransformer;

/**
 * @author ychk
 */
public class Transformer {
    public static <T> ObservableTransformer<BaseResponse<T>, T> sTransformer() {

        return responseObservable -> responseObservable.map(tResponse -> {
            if (tResponse.getCode().equals(Constants.SUCCESS)) {
                throw new RuntimeException(tResponse.getMessage());
            }
            return tResponse.getData();
        });
    }

    public static ObservableTransformer<BaseResponse, Boolean> bTransformer() {

        return responseObservable -> responseObservable.map(tResponse -> {
            if (tResponse.getCode().equals(Constants.SUCCESS)) {
                throw new RuntimeException(tResponse.getMessage());
            }
            return true;
        });
    }
}
