package com.tofly.latte_core.net.interceptor;

import android.util.Log;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;
import okhttp3.ResponseBody;

/**
 * @author ychk
 */
public class LogInterceptor implements Interceptor {

    @Override
    public Response intercept(Chain chain) throws IOException {
        Request request = chain.request();
        Response response = chain.proceed(request);
        Log.e("LogInterceptor", "request：" + request.toString());
        ResponseBody requestBody = response.peekBody(1024 * 1024);
        String content = requestBody.string();
        Log.e("LogInterceptor", "response：" + content);
        return response;
    }

}
