package com.tofly.latte_core.net.observer;

import android.content.Context;

import com.tofly.latte_core.utils.LoaderUtils;

import java.lang.ref.WeakReference;

import io.reactivex.disposables.Disposable;

/**
 * 加载进度条
 *
 * @author ychk
 */
public abstract class MyObserver<T> extends BaseObserver<T> {

    private final WeakReference<Context> weakReference;

    public MyObserver(Context context) {
        weakReference = new WeakReference<>(context);
    }

    @Override
    public void onSubscribe(Disposable d) {
        super.onSubscribe(d);
        if (weakReference.get() != null) {
            LoaderUtils.getInstance().showDialog(weakReference.get());
        }
    }

    @Override
    public void onError(Throwable e) {
        super.onError(e);
        hidDialog();
    }

    @Override
    public void onComplete() {
        super.onComplete();
        hidDialog();
    }

    public void hidDialog() {
        LoaderUtils.getInstance().stopDialog();
    }

}
