package com.tofly.latte_core.utils;

import java.io.Serializable;

/**
 * @author ychk
 * 存储用户信息
 */
public class AccountManager implements Serializable {

    private final static String SHP_NAME = "YXPC_ACCOUNT";

    private enum SignTag {
        /**
         * 用户id
         */
        USER_ID,
        /**
         * 头像
         */
        AVATAR,
        /**
         * token
         */
        TOKEN,
        /**
         * 用户账号
         */
        USER_NAME,
        /**
         * 用户姓名
         */
        REAL_NAME,
        /**
         * 密码
         */
        USER_PASSWORD,
        /**
         * 是否保存
         */
        IS_SAVE,
        /**
         * 练习电话
         */
        PHONE
    }

    public static void setUserId(String id) {
        LattePreference.setString(SHP_NAME, SignTag.USER_ID.name(), id);
    }

    public static String getUserId() {
        return LattePreference.getString(SHP_NAME, SignTag.USER_ID.name());
    }

    public static void setToken(String token) {
        LattePreference.setString(SHP_NAME, SignTag.TOKEN.name(), token);
    }

    public static String getToken() {
        return LattePreference.getString(SHP_NAME, SignTag.TOKEN.name());
    }

    public static void setUsername(String name) {
        LattePreference.setString(SHP_NAME, SignTag.USER_NAME.name(), name);
    }

    public static String getUsername() {
        return LattePreference.getString(SHP_NAME, SignTag.USER_NAME.name());
    }

    public static void setUserRealName(String realName) {
        LattePreference.setString(SHP_NAME, SignTag.REAL_NAME.name(), realName);
    }

    public static String getAvatar() {
        return LattePreference.getString(SHP_NAME, SignTag.AVATAR.name());
    }

    public static void setAvatar(String name) {
        LattePreference.setString(SHP_NAME, SignTag.AVATAR.name(), name);
    }

    public static String getPhone() {
        return LattePreference.getString(SHP_NAME, SignTag.PHONE.name());
    }

    public static void setPhone(String phone) {
        LattePreference.setString(SHP_NAME, SignTag.PHONE.name(), phone);
    }

    public static String getUserRealName() {
        return LattePreference.getString(SHP_NAME, SignTag.REAL_NAME.name());
    }

    public static void setUserPassword(String password) {
        LattePreference.setString(SHP_NAME, SignTag.USER_PASSWORD.name(), password);
    }

    public static String getUserPassword() {
        return LattePreference.getString(SHP_NAME, SignTag.USER_PASSWORD.name());
    }

    public static void setIsSave(boolean isSave) {
        LattePreference.setBoolean(SHP_NAME, SignTag.IS_SAVE.name(), isSave);
    }

    public static boolean getIsSave() {
        return LattePreference.getBoolean(SHP_NAME, SignTag.IS_SAVE.name(), true);
    }

    public static void clearAll() {
        LattePreference.clearAll(SHP_NAME);
    }
}
