package com.tofly.latte_core.utils;

import android.content.Context;
import android.content.SharedPreferences;

import com.tofly.latte_core.config.Latte;

/**
 * @author ychk
 * 共享参数工具类
 */
public final class LattePreference {

    private static SharedPreferences getAppPreference(String name) {
        return Latte.getApplicationContext().getSharedPreferences(name, Context.MODE_PRIVATE);
    }

    public static void setBoolean(String shpName, String key, boolean flag) {
        getAppPreference(shpName)
                .edit()
                .putBoolean(key, flag)
                .apply();
    }

    public static boolean getBoolean(String shpName, String key, boolean value) {
        return getAppPreference(shpName)
                .getBoolean(key, value);
    }

    public static void setInt(String shpName, String key, int flag) {
        getAppPreference(shpName)
                .edit()
                .putInt(key, flag)
                .apply();
    }

    public static int getInt(String shpName, String key) {
        return getAppPreference(shpName).getInt(key, -1);
    }

    public static void setLong(String shpName, String key, long flag) {
        getAppPreference(shpName)
                .edit()
                .putLong(key, flag)
                .apply();
    }

    public static long getLong(String shpName, String key) {
        return getAppPreference(shpName).getLong(key, -1);
    }

    public static void setString(String shpName, String key, String name) {
        getAppPreference(shpName)
                .edit()
                .putString(key, name)
                .apply();
    }

    public static String getString(String shpName, String key) {
        return getAppPreference(shpName).getString(key, "");
    }

    public static void clearAll(String shpName) {
        getAppPreference(shpName)
                .edit()
                .clear()
                .apply();
    }

}
